# MagiC-2.2 #

MagiC is a software package designed to perform systematic coarse-graining
of molecular system. The main goal is to extract structure based distribution
functions (RDF) from high resolution (fine grained) study of the system of
interest (reference system), and then to generate effective potentials which
reproduce these RDFs in a coarse-grained study by means of the inverse
Monte-Carlo method or the Iterative Boltzmann inversion method. Such potentials
can be used for a large scale simulation, thus MagiC allows user to perform
multiscale simulations.

This is the second version of MagiC software. We have moved from
https://code.google.com/p/magic/ since Google is about to close the
google code service. At present we keep the
[public repository](https://bitbucket.org/magic-su/magic-2),
[public wiki](https://bitbucket.org/magic-su/magic-2/wiki/Home)
and a private issue tracker. Please follow us on the BitBucket to get updated on the new features and releases of the code. We are grateful for any discussions, suggestions as well as bug-reports.

### Get the code ###
The most recent stable release (MagiC-2.2) can be pulled from the repository:
`hg clone https://bitbucket.org/magic-su/magic-2 magic-2.2`

Otherwise you can download a tarball from here: http://www.fos.su.se/~sasha/magic/

The previous version (MagiC-2.0) is located here: `hg clone https://bitbucket.org/magic-su/magic-2 -u magic-2.0 magic-2.0`

*NB! The repository was renamed from magic-2.0 to magic-2 due to coming release of new stable version MagiC-2.2.* If you can not pull to your local repository, just change .hg/.hgrc - file accordingly.

### Cite us ###
The theory and principles behind MagiC are published in: [ A. Mirzoev, A.P.Lyubartsev "MagiC: Software Package for Multiscale Modeling"
J. Chem. Theory and Computations, 9(3), 1512-1520 (2013) ](http://pubs.acs.org/doi/abs/10.1021/ct301019v) 
Please refer to this paper in any publication in which MagiC was used.


### Who do I talk to? ###

* Alexander Lyubartsev (alexander.lyubartsev@mmk.su.se) -
Principal investigator and method developer
* Alexander Mirzoev (alexander.mirzoev@mmk.su.se) -
admin and main software developer