#!/bin/bash
# Define location of MAGIC.
DIR=$( cd $( dirname ${BASH_SOURCE[0]} ) && pwd )
MAGIC=$DIR
echo "Location of MAGIC's root folder: " $MAGIC

export PATH=$PATH:$MAGIC/bin
if [ ! -d $MAGIC/bin ]; then 
   mkdir $MAGIC/bin
fi
# INSTALL CGTRAJ -------------------------------------------------
echo
echo "Installing CGTraj"
echo
cd CGTraj-1.3
# if you are using Intel Fortran uncomment the line below.
# make intel
# if if you are using Oracle Solaris studio uncomment the line below.
# make oracle
# The default compiler is GNU Fortran
 make gfortran
# linking compiled binary to bin folder

cd $MAGIC/bin
ln -s $MAGIC/CGTraj-1.3/cgtraj cgtraj

# INSTALL MAGIC -------------------------------------------------------------
echo
echo "Installing Magic"
echo
cd $MAGIC/magic
# Here you need to specify the compiler you are using after "make" command
# Possible options:
# intel
# intel-mpi
# oracle
# oracle-mpi
# gfortran
# gfortran-mpi
# Default choice - serial code by GNU Fortran
make gfortran

cd $MAGIC/bin
cp -f $MAGIC/magic/magic-* ./magic 
cd ..

# INSTALL RDF and MagicTools -------------------------------------------------------
echo
echo "Installing RDF and MagicTools"
echo
export PYTHONPATH=$MAGIC/MagicTools:$MAGIC/MagicTools/lib:$PYTHONPATH

echo "     Building xdrfile library"
echo
cd $MAGIC/MagicTools/xdrfile-1.1.1
./configure --enable-shared --prefix=$MAGIC/MagicTools/xdrfile-1.1.1 > make.output
make install
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$MAGIC/MagicTools/xdrfile-1.1.1
export PYTHONPATH=$MAGIC/MagicTools/xdrfile-1.1.1/src/python:$PYTHONPATH
cd $MAGIC/bin
ln -s $MAGIC/MagicTools/rdf.py ./rdf.py
cd ..
cd $MAGIC/bin
cd ..

export PATH=$PATH:$MAGIC/bin