!     
! This is the part of imcmod module, devoted to calculation of sampled RDFs
!
subroutine CalculateRDF(NAV,FNR, stdout, NSType, NA, NBond, vol, RMAX,&! RDFref_NB_riSjS,RDFref_B_riBond, 
        CORS, npairsrdf, IndexGlobNB_riSjS, IndexGlobB_riBond, &
        StateNB_iSjS, StateB_iBond, BTypeBond,iSiteinBond, jSiteinBond, kSiteInBond,&
        NpointsPotB,RMaxPotB,RMinPotB, NPairsTotalBond, NameSType, NameSite)
    implicit none
    !Global variables
    integer(4) NAV    
    real(8) vol, rmax
    integer stdout, NSType, NA, iPrint, NBond
    real(8), allocatable ::  RMaxPotB(:), RMinPotB(:)!, RDFref_NB_riSjS(:,:,:), RDFref_B_riBond(:,:)
    integer(4), allocatable:: IndexGlobNB_riSjS(:,:,:),IndexGlobB_riBond(:,:), StateNB_iSjS(:,:), StateB_iBond(:),&
        NpointsPotB(:),&
        NPairsTotalBond(:),BTypeBond(:), iSiteinBond(:,:), jSiteinBond(:,:), kSiteInBond(:,:)
    integer(8), allocatable:: npairsrdf(:,:), CORS(:)
    character(atom_name_len), allocatable:: NameSType(:), NameSite(:)
    real(8) FNR
    !Local variables
    logical, save:: FirstTime=.true.
    
    real(8) DRR
    integer(4) iNSType, jNSType,i, iBond, nr
    
    if(NAV.gt.0)then
        FNR=1./dfloat(NAV)
    else
        write(stdout,*) 'ERROR: Inverse Procedure: No averaging has been done during MC run! NAV=',NAV
        stop
    end if

    
    if (FirstTime) then
        call reshape(RAS,NA)
        RAS=0.0
        call reshape(SHELV,NA)        
        SHELV=0.0
        do NR=1,NA
            RAS(NR)=(dfloat(NR)-0.5)*RMAX/NA
            SHELV(NR)=4.d0*3.1415926535897932d0*RMAX/NA*(RAS(NR)**2+(RMAX/NA)**2/12.d0)
        end do        
!        
!        ! Generate list of site type pairs which are involved in IMC, e.g. where both pairs are moving
!        i=0
!        do iNSType=1, NSType        
!            do jNSType=iNSType+1,NSType            
!                if(Btest(StateNB_iSjS(iNStype,jNSType),5)) i=i+1
!            enddo
!        enddo
!        allocate(STypePairs(i,2)); STypePairs=0
!        do iNSType=1, NSType        
!            do jNSType=iNSType+1,NSType            
!                if(Btest(StateNB_iSjS(iNStype,jNSType),5)) then
!                    STypePairs(i,1)=iNSType
!                    STypePairs(i,2)=jNSType
!                endif
!            enddo
!        enddo
!        
    endif
    
    call reshape2(npairs,NSType,NSType)
    npairs=0
    
    if (FirstTime) then
        if (.not. allocated(Sref_NB_riSjS)) allocate(Sref_NB_riSjS(Na, NSType,NSType))  ! In best case this shall be moved to Readio.Initiate
        Sref_NB_riSjS=0.0
        if (.not. allocated(RDFcalc_NB_riSjS)) allocate(RDFcalc_NB_riSjS(NA, NSType,NSType))
        RDFcalc_NB_riSjS=0.0
        if (.not. allocated(Scalc_NB_riSjS)) allocate(Scalc_NB_riSjS(NA, NSType,NSType))
        Scalc_NB_riSjS=0.0
        
    endif
    
    ! Count number of pairs for NB
    do iNSType=1, NSType        
        npairs(iNSType,iNSType)=npairsrdf(iNSType,iNSType)+sum(CORS(IndexGlobNB_riSjS(1:NA,iNSType,iNSType)))
        do jNSType=iNSType+1,NSType            
            if(Btest(StateNB_iSjS(jNStype,iNSType),5)) then
                npairs(jNSType,iNSType)=npairsrdf(jNSType,iNSType)+npairsrdf(iNSType,jNSType)+&
                                                            sum(CORS(IndexGlobNB_riSjS(1:NA,jNSType,iNSType)))
                npairs(iNSType,jNSType)=npairs(jNSType,iNSType)
            endif
        enddo
    enddo
    npairs= npairs*FNR
!    write(*,*) 'DEBUG: IMCMOD.calcrdf: npairs=',npairs       
    !Get reference <S> if exist
    if (FirstTime) then
        do iNSType=1, NSType        
            do jNSType=iNSType, NSType                   
              if (BTest(StateNB_iSjS(jNSType,iNSType),4)) & ! If RDFref exists for this types pair
                    Sref_NB_riSjS(:,jNSType,iNSType)=RDFref_NB_riSjS(:,jNSType,iNSType)*NPairs(jNSType,iNSType)*SHELV(:)/VOL
    !               else                    
            enddo
            Sref_NB_riSjS(:,iNSType,:)=Sref_NB_riSjS(:,:,iNSType)
        enddo    
    endif
    
    !Get sampled <S>
    do iNSType=1, NSType        
        do jNSType=iNSType, NSType            
            Scalc_NB_riSjS(1:NA,jNSType,iNSType)=CORS(IndexGlobNB_riSjS(1:NA,jNSType,iNSType))*FNR
        enddo
    enddo
    !Get sampled RDF             
    do iNSType=1, NSType        
        do jNSType=iNSType, NSType
            if(Btest(StateNB_iSjS(jNStype,iNSType),5)) & ! if the pair move
              RDFcalc_NB_riSjS(1:NA,jNSType, iNSType)=Scalc_NB_riSjS(1:NA,jNSType,iNSType)*VOL/(NPairs(jNSType,iNSType)*SHELV(1:NA))   ! calculated RDF
        enddo
!        RDFcalc_NB_riSjS(1:NA,:, iNSType)=RDFcalc_NB_riSjS(1:NA,iNSType, :)
    enddo
    
    !  Count numbers of points in bonds:
    if (NBond.gt.0) then
        call reshape2(Sref_B_riBond, maxval(NPointsPotB(:)),NBond)
        Sref_b_riBond=0.0
        call reshape2(Scalc_B_riBond, maxval(NPointsPotB(:)),NBond)
        Scalc_B_riBond=0.0
        call reshape2(RDFcalc_B_riBond, maxval(NPointsPotB(:)),NBond)
        RDFcalc_B_riBond=0.0
    else ! No bonds
        ! Allocate dummy arrays
        call reshape2(Sref_B_riBond, 1,1)
        call reshape2(Scalc_B_riBond, 1,1)
        call reshape2(RDFcalc_B_riBond, 1,1)        
    endif
        
! calculate S sampled    
    do iBond=1, NBond
!        do iR=1, NpointsPotB(iBond)
        if(Btest(StateB_iBond(iBond),5)) &
            Scalc_B_riBond(1:NpointsPotB(iBond),iBond)=CORS(IndexGlobB_riBond(1:NpointsPotB(iBond),iBond))*FNR
!        enddo
    enddo
! Reference RDF: RDFref_B_riBond(:,:)

! Calculate RDF sampled    
    do iBond=1, NBond
        if(Btest(StateB_iBond(iBond),5)) then
            DRR=(RMaxPotB(iBond)-RMinPotB(iBond))/NPointsPotB(iBond)
            RDFcalc_B_riBond(1:NpointsPotB(iBond),iBond)=Scalc_B_riBond(1:NpointsPotB(iBond),iBond)/(NPairsTotalBond(iBond)*DRR)       ! calculated RDF
        endif
    enddo

    ! Calculate S reference
    if (FirstTime) then
        do iBond=1, NBond
            if(Btest(StateB_iBond(iBond),5)) then
             if (BTest(StateB_iBond(iBond),4)) then ! If reference RDF exist
                DRR=(RMaxPotB(iBond)-RMinPotB(iBond))/NPointsPotB(iBond)
                Sref_B_riBond(1:NpointsPotB(iBond),iBond)=RDFref_B_riBond(1:NpointsPotB(iBond),iBond)*NPairsTotalBond(iBond)*DRR      
             endif
            endif
        enddo
    endif
!    FirstTime=.False.
end subroutine CalculateRDF

subroutine PrintRDF(LRDF,NAV, iPrint, stdout, NSType, NA, NBond,&! RDFref_NB_riSjS, RDFref_B_riBond, 
        CORS, IndexGlobB_riBond, StateNB_iSjS, StateB_iBond, BTypeBond,iSiteinBond, jSiteinBond, kSiteInBond,&
        NpointsPotB,RMaxPotB,RMinPotB, NPairsTotalBond, NameSType, NameSite)
                
    implicit none
    !Global variables
    logical LRDF
    integer stdout, NSType, NA, iPrint, NBond, NAV
!    real(8), allocatable :: RDFref_NB_riSjS(:,:,:), RDFref_B_riBond(:,:)
    integer(4), allocatable:: StateNB_iSjS(:,:), StateB_iBond(:), IndexGlobB_riBond(:,:),&
        NpointsPotB(:),BTypeBond(:), iSiteinBond(:,:), jSiteinBond(:,:), kSiteInBond(:,:),NPairsTotalBond(:)
    integer(8), allocatable:: CORS(:)
    character(atom_name_len), allocatable:: NameSType(:), NameSite(:)
    
    !Local variables
    real(4) DRR
    integer(4) iNSType, jNSType,i, iBond, nr
    
    real(8), allocatable ::  RMaxPotB(:), RMinPotB(:)
    character*12 str
    
! - Printing all the RDFs----------------------------------------------------------

if ((.not. LRDF).or.(iPrint.ge.6)) then
    
!   ! Print NB RDFs - considering the case:
    do iNSType=1,NSType
        do jNSType=iNSType,NSType
!                    if ((LMOVE(MTypeSType(iNSType)).or.LMOVE(MTypeSType(jNSType))).and.& ! No RDF, but potential is provided
!                        BTest(StateNB_iSjS(iNSType,jNSType),3).and.&
!                        (.not.BTest(StateNB_iSjS(iNSType,jNSType),4))) then                        
            if ((StateNB_iSjS(jNSType,iNSType).gt.3) .and.(Btest(StateNB_iSjS(jNSType,iNSType),5))) then 
                write(stdout,*)' This pair:',NameSType(iNSType),' - ',NameSType(jNSType),'   pairs: ',npairs(jNSType,iNSType)
                write(stdout,*)'   R       RDF   RDFref     <S(R)> ', '   <S(R)ref>    delta           typ '
                do NR=1,NA
                    if (RDFref_NB_riSjS(NR, jNSType, iNSType).ne.0) &
                    write(stdout,'(f10.4,2f10.5,2f10.3,5x,3a4)') &
                       RAS(NR),&
                       RDFcalc_NB_riSjS(NR,jNSType,iNSType),&
                       RDFref_NB_riSjS(NR,jNSType,iNSType),&
                       Scalc_NB_riSjS(NR,jNSType,iNSType),&
                       Sref_NB_riSjS(NR,jNSType,iNSType),&
                       'rdf:',NameSType(iNSType),NameSType(jNSType)
                end do
            end if                    
        end do
    end do

!    Intramolecular RDF-s    
    write(stdout,*)'   Intramolecular RDF-s'
    do iBond=1, NBond
        ! if the molecule is allowed to move, and either RDF is defined or potential is fixed
        if ((StateB_iBond(iBond).gt.3).and.(btest(stateB_iBond(iBond),5)) )then
            if (BTypeBond(iBond).eq.1) then
                write(str,'(2a4)') NameSite(iSiteInBond(iBond,1)), NameSite(jSiteInBond(iBond,1))
                write(stdout,*)' This pair:',NameSite(iSiteInBond(iBond,1)),' - ',NameSite(jSiteInBond(iBond,1)),' intramolecular '
                write(stdout,*)'   R       RDF   RDFref     <S(R)>   <S(R)ref>    delta           typ '
            elseif (BTypeBond(iBond).eq.2) then
                write(str,'(3a4)') NameSite(iSiteInBond(iBond,1)),NameSite(kSiteInBond(iBond,1)), NameSite(jSiteInBond(iBond,1)) 
                write(stdout,*)' This triplet:',NameSite(iSiteInBond(iBond,1)),' - ',NameSite(kSiteInBond(iBond,1)),&
                        ' - ',NameSite(jSiteInBond(iBond,1))
                write(stdout,*)'   Phi       ADF   ADFref     <S(phi)> ', '   <S(phi)ref>    delta           typ '
            endif

            if((IPRINT.ge.6.and.NpointsPotB(iBond).gt.0))then
                write(stdout,*) ' NPAIRS ',NPairsTotalBond(iBond), ' NpairAccumulated ',&
                    (sum(CORS(IndexGlobB_riBond(1:NpointsPotB(iBond),iBond)))/NAV)
            endif
            do I=1,NpointsPotB(iBond)
                if((RDFref_B_riBond(I,iBond).ne.0)) then
                    DRR=(RMaxPotB(iBond)-RMinPotB(iBond))/NPointsPotB(iBond)                    
                    write(stdout,'(f10.4,2f10.5,2f10.3,5x,a4,a12)')&
                       RMinPotB(iBond)+DRR*(I-0.5) ,&
                       RDFcalc_B_riBond(i, iBond),&
                       RDFref_B_riBond(i,iBond),&
                       Scalc_B_riBond(i,iBond),&
                       Sref_B_riBond(i,iBond),&
                       'rdf:',trim(str)
                 endif
            enddo
        endif
    end do
endif
end subroutine PrintRDF

subroutine CalcDeviation(DevS, DevRDF, NSType, NBond, NPointsPotB, NA, StateNB_iSjS, StateB_iBond)
    !Global
    real(8) DevS, DevRDF
    integer(4) NSType, NBond, NPointsPotB(:), NA, StateNB_iSjS(:,:), StateB_iBond(:)
    !Local    
    integer is,js, NR, ipp
    real(8) dDevS, dDevRDF
        
!    DevS=sum((Sref_NB_riSjS-Scalc_NB_riSjS)**2)
!    DevRDF=sum((RDFref_NB_riSjS-RDFcalc_NB_riSjS)**2)
!    DevS=DevS+sum((Sref_B_riBond-Scalc_B_riBond)**2)    
!    DevRDF=DevRDF+sum((RDFref_B_riBond-RDFcalc_B_riBond)**2)
!
    DevS=0
    DevRDF=0
    do iS=1, NSType
        do jS=iS, NSType
            if(Btest(StateNB_iSjS(jS,iS),5).and.Btest(StateNB_iSjS(jS,iS),4)) then
!                write(*,*) 'DEBUG imcmod.calcrdf:',(Btest(StateNB_iSjS(jS,iS),5)),Btest(StateNB_iSjS(jS,iS),4)
                Devs=devs+sum((Sref_NB_riSjS(:, jS, iS)-Scalc_NB_riSjS(:,jS,iS))**2)
                DevRDF=devRDF+sum((RDFref_NB_riSjS(:, jS, iS)-RDFcalc_NB_riSjS(:,jS,iS))**2)
            endif
        enddo
    enddo
    do ipp=1, NBOND
        if(Btest(StateB_iBond(ipp),5)) then
            Devs=devs+sum((Sref_B_riBond(:, ipp)-Scalc_B_riBond(:,ipp))**2)
            DevRDF=devRDF+sum((RDFref_B_riBond(:, ipp)-RDFcalc_B_riBond(:,ipp))**2)
        endif
    enddo
end subroutine CalcDeviation

subroutine Regularization(REGP, DPOTM, RTM, CORMF,&
    NSType, NBond, StateNB_iSjS, StateB_iBond, NpointsPotB, IndexGlobNB_riSjS, IndexGlobB_riBond)
    !Global
    real(8) REGP, DPOTM, RTM
    real(8), allocatable:: CORMF(:)
    integer(4), allocatable:: StateNB_iSjS(:,:), StateB_iBond(:), NpointsPotB(:),&
            IndexGlobNB_riSjS(:,:,:), IndexGlobB_riBond(:,:)
    integer NSType, NBond
    
    !Local
    real(8), allocatable:: DIFRC(:), DIFMP(:)
    integer iSType, jSType, iBond, NP
    
!    if (.not. allocated(DIFRC)) then
    allocate(DIFRC(size(Sref_NB_riSjS,1)))
    allocate(DIFMP(size(Sref_NB_riSjS,1)))
!    endif
    
    do iSType=1, NSType
        do jSType=iSType, NSType
            if (Btest(StateNB_iSjS(jSType,iSType),5).and.Btest(StateNB_iSjS(jSType,iSType),4)) then  ! 5th and 4th bits are 1, e.g. Move and RDFref
                call Regularize(Sref_NB_riSjS(:,jSType,iSType), Scalc_NB_riSjS(:,jSType,iSType), REGP, DPOTM, RTM,DIFRC,DIFMP)                
                COR(IndexGlobNB_riSjS(:,jSType, iSType))=DIFRC
                CORMF(IndexGlobNB_riSjS(:,jSType, iSType))=DIFMP
            endif
        enddo
    enddo

    call reshape(DIFRC,size(Sref_B_riBond,1))
    call reshape(DIFMP,size(Sref_B_riBond,1))
!    DIFRC(:)=0.0
!    DIFMP(:)=0.0
    do iBond=1, NBond
        if (Btest(StateB_iBond(iBond),5).and. Btest(StateB_iBond(ibond),4)) then ! 5th and 4th bits are 1, e.g. Move and RDFref
            NP=NpointsPotB(iBond)
            call Regularize(Sref_B_riBond(1:NP,iBond), Scalc_B_riBond(1:NP,iBond),REGP, DPOTM, RTM,DIFRC(1:NP),DIFMP(1:NP))
            COR(IndexGlobB_riBond(1:NP,iBond))=DIFRC(1:NP)
            CORMF(IndexGlobB_riBond(1:NP,iBond))=DIFMP(1:NP)            
        endif
    enddo
end subroutine Regularization

subroutine Regularize(Ref, Calc, REGP, DPOTM, RTM, DIFRC,DIFMP)
    real(8) DIFRC(:), DIFMP(:)
    real(8) Ref(:), Calc(:)
    real(8) REGP, DPOTM, RTM
    
    ! Calculate and scale down differences
    DIFRC=(Calc-Ref)*REGP    
    DIFMP=0.0
    ! This is only needed for IBI. and can be transferred to the relevant subroutine
    where ((Calc.gt.1.d-50 ).and.(Ref.gt.1.d-50 )) DIFMP=dlog(Calc/Ref)*RegP        
    where((Calc.lt.1.d-50 ).and.(Ref.gt.1.d-50 ))  DIFMP=-DPOTM
    where ((Calc.gt.1.d-50 ).and.(Ref.le.1.d-50 )) DIFMP=DPOTM
    
    ! Scaling of large relative changes
    where ((Calc.ne.0.0) .and. (abs(DIFRC).gt.Calc*RTM)) DIFRC=sign(Calc*RTM,DIFRC)
            
end subroutine Regularize
