subroutine PrintPotential(NBond,NSType, NA,LIMC, irep, itercorr, FRT, FNR, REGP, &
    LPotCorrCheck,  CORS, IND, INDI,IndexGlobNB_riSjS,IndexGlobB_riBond,&
    NPointsPotB,RMinPotB,RMaxPotB, StateNB_iSjS, StateB_iBond,PotB_riBond,PotNB_riSjS,&
    NameSite,NameSType,&    
    BTypeBond,MTypeBond, NPairsTotalBond,iSiteinBond,jSiteinBond,kSiteinBond,&
    iPrint, stdout)

    ! Global Variables
    integer(4) iPrint, stdout,NA, NBond, NSType,  IREP, itercorr
    logical LPotCorrCheck, LIMC
    integer(8), allocatable:: CORS(:)
    integer(4),allocatable::IND(:,:,:),NPointsPotB(:),INDI(:,:),IndexGlobB_riBond(:,:),IndexGlobNB_riSjS(:,:,:),&
        iSiteinBond(:,:),jSiteinBond(:,:),kSiteinBond(:,:),&
        BTypeBond(:),MTypeBond(:), NPairsTotalBond(:), StateNB_iSjS(:,:), StateB_iBond(:)
    real(8),allocatable:: PotB_riBond(:,:),PotNB_riSjS(:,:,:),RMinPotB(:),RMaxPotB(:)
    real(8) FNR,FRT, regp
    character(atom_name_len), allocatable:: NameSite(:),NameSType(:)
!    
! Local Variables    
    integer(4) iNSType, jNSType, NR, iBond, IAT, JAT, KAT
    real(8) DRR
    character*64 str,fmt ! Comment about potential line - either    
    
    if (.not.LPotCorrCheck) then
        write(stdout,*)'------------------------------------'
	write(stdout,*) 'Final Corrected effective potential', IREP
    else
        write(stdout,*)'Intermediate Corrected effective potential', IterCorr
    endif
    
    if(LIMC)then
       write(stdout,*)' IMC - crosscorrelation approach '
    else
       write(stdout,*)'  Mean-field approach'
       write(stdout,*)' regularization parameter  ',REGP
    end if
    
    do iNSType=1,NSType
        do jNSType=iNSType,NSType
            if ((StateNB_iSjS(jNSType,iNSType).gt.3)&
                .and.(BTest(StateNB_iSjS(jNSType,iNSType),5))) then 
                write(stdout,*)' This pair:',NameSType(iNSType),' - ',NameSType(jNSType),&
                    ' intermolecular pairs: ',npairs(iNSType,jNSType)
                write(stdout,*)'   R        RDF        RDFref     Potential  Init.Pot.             REP NCheck'            
                do NR=1,NA
                    if((IND(NR,jNSType,iNSType).eq.1).or.&
                        ((IND(NR,jNSType,iNSType).eq.-3).and.(RDFref_NB_riSjS(NR,jNSType, iNSType).ne.0.0))) then
                        write(stdout,'(f9.4,5f11.4,3x,a4,2a5,a11)') &
                            RAS(NR),&
                            RDFcalc_NB_riSjS(NR,jNSType,iNSType),&
                            RDFref_NB_riSjS(NR,jNSType,iNSType),&
                            (PotNB_riSjS(NR,jNSType,iNSType)+COR(IndexGlobNB_riSjS(NR,jNSType,iNSType)))*FRT,&                            
                            PotNB_riSjS(NR,jNSType,iNSType)*FRT,&
                            COR(IndexGlobNB_riSjS(NR,jNSType,iNSType)),&                            
                            'pot:',NameSType(iNSType),NameSType(jNSType),comment                    
                    endif
                end do
            end if                    
        end do
    end do
    
!    Intramolecular RDF-s    
    write(stdout,*)'   Intramolecular Potentials'
    do iBond=1, NBond
        ! if the molecule is allowed to move, and either RDF is defined or potential is fixed
        if ((Btest(StateB_iBond(iBond),5)).and.(StateB_iBond(iBond).gt.3)) then
            write(fmt,*) atom_name_len+1 ! length of atom-name field
            if (BTypeBond(iBond).eq.1) then
                write(str,'(2a'//trim(adjustl(fmt))//')') NameSite(iSiteInBond(iBond,1)), NameSite(jSiteInBond(iBond,1))
                write(stdout,*)' This pair:',NameSite(iSiteInBond(iBond,1)),' - ',NameSite(jSiteInBond(iBond,1)),' intramolecular '
                write(stdout,*)'   R        RDF     RDFref    Potential      Init.Pot.'
            elseif (BTypeBond(iBond).eq.2) then
                write(str,'(3a'//trim(adjustl(fmt))//')') NameSite(iSiteInBond(iBond,1)),NameSite(kSiteInBond(iBond,1)),&
                             NameSite(jSiteInBond(iBond,1)) 
                write(stdout,*)' This triplet:',NameSite(iSiteInBond(iBond,1)),' - ',NameSite(kSiteInBond(iBond,1)),&
                        ' - ',NameSite(jSiteInBond(iBond,1))
                write(stdout,*)'   Phi        ADF     ADFref    Potential     Init.Pot.'
            endif

            if((IPRINT.ge.6.and.NpointsPotB(iBond).gt.0))then
                write(stdout,*) ' NPAIRS ',NPairsTotalBond(iBond), ' NpairAccumulated ',&
                    (sum(CORS(IndexGlobB_riBond(1:NpointsPotB(iBond),iBond)))*FNR)
            endif
            do NR=1,NpointsPotB(iBond)                
                DRR=(RMaxPotB(iBond)-RMinPotB(iBond))/NPointsPotB(iBond)                    
                write(fmt,*) 3*(atom_name_len+1) ! triple length of atom-name field
                write(stdout,'(f10.4,5f10.5,5x,a4,a'//trim(adjustl(fmt))//', I4,a11)')&
                    RMinPotB(iBond)+DRR*(NR-0.5) ,&
                    RDFcalc_B_riBond(NR, iBond),&                    
                    RDFref_B_riBond(NR,iBond),&                    
                    (PotB_riBond(NR,iBond)+COR(IndexGlobB_riBond(NR,iBond)))*FRT,&
                    PotB_riBond(NR,iBond)*FRT,&
                    COR(IndexGlobB_riBond(NR,iBond)),&                    
                    'pot:',trim(str), INDI(NR,iBond), comment
            enddo
        endif
    end do
    

end subroutine PrintPotential

subroutine ApplyCorrections(NSType, NBond, NA, StateNB_iSjS, StateB_iBond, NPointsPotB, IndexGlobNB_riSjS, IndexGlobB_riBond,&
                PotNB_riSjS, PotB_riBond, COR)

!Global
integer(4) NSType, NBond, NA
integer(4), allocatable:: StateNB_iSjS(:,:), StateB_iBond(:), NPointsPotB(:), IndexGlobNB_riSjS(:,:,:), IndexGlobB_riBond(:,:)
real(8), allocatable:: PotNB_riSjS(:,:,:), PotB_riBond(:,:), COR(:)
!Local
    integer(4) iNSType, jNSType, iBOnd, NP
    
do iNSType=1,NSType
    do jNSType=iNSType,NSType
        if ((StateNB_iSjS(jNSType,iNSType).gt.3)&
            .and.(BTest(StateNB_iSjS(jNSType,iNSType),5))) then 
            PotNB_riSjS(1:NA,jNSType, iNSType)=PotNB_riSjS(1:NA,jNSType, iNSType)+COR(IndexGlobNB_riSjS(1:NA,jNSType,iNSType))
        end if                    
        PotNB_riSjS(1:NA,iNSType, jNSType)=PotNB_riSjS(1:NA,jNSType, iNSType)
    end do
end do   

do iBond=1, NBond
    if ((Btest(StateB_iBond(iBond),5)).and.(StateB_iBond(iBond).gt.3)) then 
        np=NPointsPotB(iBOnd)
        PotB_riBond(1:NP,iBOnd)=PotB_riBond(1:NP,iBOnd)+COR(IndexGlobB_riBond(1:NP,iBOnd))
    endif
enddo
end subroutine ApplyCorrections