subroutine MCMioReadSites(NMType, NameMType,NSiteMType, SumMassMType, &
    NSite, NameSite, RSite, MassSite, ChargeSite, IndexSTypeSite, NameSTypeSite,MTypeSite,&
    IPrint, stdout)
    ! Global variables
    integer NMType, IPrint, stdout
    integer, allocatable:: IndexSTypeSite(:),MTypeSite(:)
    
    integer,allocatable:: NSiteMType(:)
    integer NSite
    character(atom_name_len), allocatable:: NameSite(:), NameSTypeSite(:)
    real(8), allocatable:: RSite(:,:),MassSite(:), ChargeSite(:)                           
    real(8), allocatable:: SumMassMType(:)
    character(mol_name_len),allocatable:: NameMType(:)
    ! Local variables
    character(filename_text) iFilename
    character(mcm_text) str, args(20)
    integer iostt, iNSite, iMType, BeginSite, EndSite, IE,i,j, nargs 
        
    call reshape(SumMassMType,NMType)
    call reshape(NSiteMType,NMType)
    NSite=0 ! Total Number of sites 
!    write(*,*) 'DEBUG readsites', NameMType(:)
    do iMType=1, NMType
        !  1 Open the .mcm file
!        write(*,*) 'DEBUG', trim(NameMType(iMType))
        iFilename=(trim(adjustl(NameMType(iMType)))//'.mcm')		
!        write(*,*) 'DEBUG', iFilename
        open(unit=4,file=iFilename,status='old',iostat=iostt)
        if (iostt .ne. 0) then
            write(stdout,*) 'ERROR: Reading MCM-file: mcm-file ',iFilename,' is not found!'
            stop
        endif            
        if(IPRINT.ge.5) write(stdout,*) '*** MOLECULE ',trim(adjustl(NameMType(iMType))),',  Type  No.',iMType       
        STR=TAKESTR(4,Iostt)
    !  Number of atoms
        read(STR,*,iostat=iostt) iNSite
        if (iostt .ne. 0) then
            write(stdout,*) 'ERROR: Reading MCM-file ',iFilename,' line 1'
            stop
        endif
        if(IPRINT.ge.6)  write(stdout,*)'*** NR OF Sites (ATOMS) in the molecular type: ',iNSite
        NSiteMType(iMType)=iNSite     
        NSite=NSite+iNSite
        call reshape(NameSite,NSite)
        call reshape(MTypeSite,NSite)
        call reshape2(RSite,NSite,3)                       
        call reshape(MassSite,NSite)
        call reshape(ChargeSite,NSite)
        call reshape(IndexSTypeSite,NSite) 
        call reshape(NameSTypeSite,NSite)               
       
!   Cycle over atoms
        BeginSite=NSite-iNSite+1
        EndSite=NSite
        MTypeSite(BeginSite:EndSite)=iMType
        do I=BeginSite, EndSite
            STR=TAKESTR(4,iostt)            
            call parse(str,' ',args,nargs)
            if (nargs .ne. 8) then
                write(stdout,*) 'ERROR: Reading MCM-file ',iFilename,' line ', i-BeginSite+2
                write(stdout,*) 'Number of arguments in the line is not equal to 8 (Name, X, Y, Z, Mass, Charge, IType, NameType)'
                stop
            endif
            NameSite(I)=adjustl(trim(args(1)))
            call str2value(args(2),RSite(i,1),iostt)
            call str2value(args(3),RSite(i,2),iostt)
            call str2value(args(4),RSite(i,3),iostt)
            call str2value(args(5),MassSite(i),iostt)
            call str2value(args(6),ChargeSite(i),iostt)
            call str2value(args(7),IndexSTypeSite(i),iostt)
            NameSTypeSite(i)=adjustl(trim(args(8)))
            if (iostt .ne. 0) then
               write(stdout,*) 'ERROR: Reading MCM-file ',iFilename,' line ', i-BeginSite+2
               stop
            endif
            NameSTypeSite(i)=trim(adjustl(NameSTypeSite(i)))
            if(IPRINT.ge.6) write(stdout,'(a5,a4,a4,3f7.3,a3,f8.4,a3,f6.3,a15,i3,a14,a8)') &
                'Site ',NameSite(I),'  R=',(RSite(i,J),J=1,3), ' M=',MassSite(I),' Q=',ChargeSite(I),&
                ' SiteTypeIndex=',IndexStypeSite(I), ' SiteTypeName=', NameSTypeSite(i)                                   
        end do ! Over sites of the molecule 
        
        SumMassMType(iMType) = SUM(MassSite(BeginSite:EndSite))        
        write(stdout,*)' Total mass of molecular type ',trim(NameMType(iMType)), ' = ',SumMassMType(iMType)
        if(IPRINT.ge.6) write(stdout,*)'Reading MCM-file. Setting local COM to 0.  MolecularType  ',trim(NameMType(iMType))
        call MCMioSetCOMZero(BeginSite,EndSite,RSite,MassSite,NameSite,iPrint,stdout)        
                
        close(4)
        
    enddo ! End of Loop over Molecular Types
    write(stdout,*) ''
    write(stdout,*) 'Total number of Sites in the system:', NSite
    end subroutine MCMioReadSites
