subroutine PotReadPropNB(text,iFilename, bPotential, ePotential, NameSType, AtomTypesPairStr, AtomTypesPair,&
    Rmin, Rmax, PRmin, PRmax, Npoints, PNpoints)
    ! Global Variables
    character(pot_text), allocatable :: text(:)
    character(filename_text) iFilename
    character(pot_text) PName
    integer bPotential, ePotential, Npoints, PNPoints, bTable, eTable, AtomTypesPair(2)
    character(atom_name_len), allocatable:: NameSType(:)
    character(atom_name_len) AtomTypesPairStr(2)
    real(8) PRmin, PRmax, Rmax, Rmin

! Local Variables
    integer  i,j,ierr
    character(pot_text) field, l, str !AtomTypesPairStr(2)
    logical flag
    
    do j=bPotential, ePotential ! Read properties which are specific to potential-type 
        call ReadLineFromText(text,j,str,ierr)
        l=str
        call split(l,'=',field)
        select case (uppercase(trim(adjustl(field))))
            case ('ATOMTYPES')   
                ierr=2
                call parse(l,',',AtomTypesPairStr,ierr)
                if (ierr.ne.2) then
                    write(stdout,*) 'ERROR: Reading Potential: File: ',trim(iFilename),' line:',j,&
                               ' Can not read the numbers of atomic types interacting by the potential.',l
                    write(stdout,*) '"',trim(adjustl(AtomTypesPairStr(1))),'" ',' "',trim(adjustl(AtomTypesPairStr(2))),'"'           
                    stop
                endif
                flag=.false.
                do i=1, size(NameSType)
                    if (AtomTypesPairStr(1).eq.NameStype(i)) then 
                        flag=.true.
                        AtomTypesPair(1)=i
                    endif
                enddo
                if (.not. flag) then
                    write(stdout,*) 'ERROR: Reading Potential:  File: ',trim(iFilename),&
                    ' line:',j, ' unknown atom/site type ',AtomTypesPairStr(1)
                    stop
                endif
                flag=.false.
                do i=1, size(NameSType)
                    if (AtomTypesPairStr(2).eq.NameStype(i)) then 
                        flag=.true.
                        AtomTypesPair(2)=i
                    endif
                enddo
                if (.not. flag) then
                    write(stdout,*) 'ERROR: Reading Potential:  File: ',trim(iFilename),&
                    ' line:',j, ' unknown atom/site type ',AtomTypesPairStr(2)
                    stop
                endif               
            case default
                continue !write(stdout,*) 'Debug: Unknown line:',trim(adjustl(str))
        end select
    enddo
    
!   Check consistency with Common properties
    if (PRMAX.ne.RMAX) then
        write(stdout,*) 'ERROR: Reading Potential: File: ',trim(iFilename),&
            ' line:',j,' MAX value for the NB-potential:',PRMAX,&
                    ' differs from general MAX: ', RMAX
        stop                                           
    endif
    if (PRMIN.ne.RMIN) then
        write(stdout,*) 'ERROR: Reading Potential: File: ',trim(iFilename),&
            ' line:',j,' MIN value for the NB-potential:',PRMIN,&
                    ' differs from general MIN: ', RMIN
        stop                                           
    endif
    if (PNpoints.ne.Npoints) then
        write(stdout,*) 'ERROR: Reading Potential: File: ',trim(iFilename),&
            ' line:',j,' Npoints value for the NB-potential:',PNpoints,&
                    ' differs from general Npoints: ', Npoints
        stop                  
    endif
end subroutine
