!     
! File:   potreadpropcommon.f90
! Author: sasha
!
! Created on December 16, 2013, 1:47 PM
!
module rdfio   
    use precision
    use strings
    use utilsmod
    use dynarray
    implicit none
    
    integer, private:: iPrint, stdout

    contains
include "rdfio_readrdf.f90"
include "rdfio_rdfreadpropcommon.f90"
include "rdfio_rdfreadpropnb.f90" 
include "rdfio_rdfreadpropb.f90"
include "rdfio_rdfreadpropa.f90"
include "rdfio_rdfreadgeneralsection.f90"
include "rdfio_rdfreadtablecommon.f90"
include "rdfio_rdfreadincludedrdf.f90"

subroutine GetEndOfRDFSection(text,i,iend,bRDF,eRDF)
! Global variables
    integer i, bRDF, eRDF,iend
    character(rdf_text), allocatable :: text(:)

! Local variables
    integer j, ierr
    character(rdf_text) str,l
    
    bRDF=i
    j=bRDF+1
    do j=bRDF+1,iend ! Search for &EndRDF
        call ReadLineFromText(text,j,l,ierr)
        if(uppercase(trim(l))=='&ENDRDF') then 
            eRDF=j
            exit
        elseif ((uppercase(trim(l))=='&RDF').or.(j.eq.iend)) then
            write(stdout,*) 'ERROR: Reading RDF: Can not find end of the section &RDF started at line ',bRDF 
            stop 
        endif
    enddo
end subroutine

subroutine GetRDFFileLength(iFilename,iend)
    character(filename_text) ifilename
    character(rdf_text) l
    integer i, ierr, iend, iostt
    ! Open the RDF file and scan it  for number of lines (variable iend)
    open(unit=4,file=iFilename,status='old',iostat=iostt)
    if (iostt .ne. 0) then
        write(stdout,*)'ERROR: RDF input file ',trim(iFilename),' is not found!'
	stop
    endif
    i=0
    iend=0
    ierr=0
    do 
        read(4,'(a)',end=99) l
        iend=iend+1        
        cycle ! read next line
99      ierr=1 ! Return error flag when end of file
        if (ierr==1) then
            write(stdout,*) 'End of the RDF input file ',trim(iFilename),' reached.',iend,' lines read.'
            exit
        endif
    enddo
    close(4)    
end subroutine

subroutine rdfioSetStdOut(stdout_, iPrint_)
        integer stdout_, iPrint_
        stdout=stdout_
        iPrint=iPrint_                
end subroutine                
end