
subroutine ReadIncludedRDFSection(IncludeFileName, text, iend, bInclude, eInclude, bTable, eTable)
!! Global variables
     character(rdf_text) IncludeFileName
     integer iend, bInclude, eInclude
     integer bTable, eTable
     character(rdf_text), allocatable :: text(:)
! Local variables   
     integer i,j, cnt_bInclude, cnt_eInclude, ierr, iostt, cnt_eTable, cnt_bTable

    character(rdf_text) l,str,field
    logical FlagTableFound
    
    ! Open the RDF file and scan it  for number of lines (variable iend)    
    call GetRDFFileLength(IncludeFileName,iend)
! Allocate array for the file    
    if (allocated(text)) deallocate(text)
    allocate(text(iend))
! Read the file to the array text
    open(unit=2,file=IncludeFileName,status='old',iostat=iostt)
    do i=1,iend
        read(2,'(a)') l
        text(i)=trim(adjustl(l))
!        write(stdout,*) text(i)
    enddo
    close(2)
!    write(stdout,*) 'Debug: iend=',iend   
    i=1
    bInclude=0
    eInclude=0
    cnt_bInclude=0
    cnt_eInclude=0
    cnt_eTable=0
    cnt_bTable=0
    do while (i.le.iend)
        call ReadLineFromText(text,i,l,ierr)
        ! Indicate presence of &Include 
        if(uppercase(trim(l))=='&INCLUDEDRDF') then
            bInclude=i
            cnt_bInclude=cnt_bInclude+1
        endif
        if(uppercase(trim(l))=='&ENDINCLUDEDRDF') then 
            eInclude=i
            cnt_eInclude=cnt_eInclude+1
        endif
        i=i+1
    enddo
    ! Indicate presence of &EndInclude and check consistency
    if ((cnt_bInclude.gt.1) .or. (cnt_eInclude.gt.1)) then
        write(stdout,*) 'ERROR: Reading RDF: file ',trim(IncludeFileName), &
        ' more than one line with tag &IncludedRDF or &EndIncludedRDF found '
        stop
    endif
    if (bInclude.eq.0) then
        write(stdout,*) 'ERROR: Reading RDF: file ',trim(IncludeFileName), ' Can not find begin of section &IncludedRDF'
        stop
    endif
    if (eInclude.eq.0) then
        write(stdout,*) 'ERROR: Reading RDF: file ',trim(IncludeFileName),  'Can not find end of section &EndIncludedRDF'
        stop 
    endif
    if (bInclude.gt.eInclude) then
        write(stdout,*) 'ERROR: Reading RDF: file ',trim(IncludeFileName), &
        ' The section &IncludedRDF starts at line ',bInclude, 'and ends at line ',eInclude
        stop
    endif
    
!        write(stdout,*) 'Reading Included RDFfile'
    do j=bInclude, eInclude
        call ReadLineFromText(text,j,str,ierr)
        l=str
        call split(l,'=',field)        
        select case (uppercase(trim(adjustl(field))))
             case ('&TABLE')
                   FlagTableFound=.true.
                   bTable=j
                   cnt_bTable=cnt_bTable+1
            case ('&ENDTABLE')
                   eTable=j
                   cnt_eTable=cnt_eTable+1                        
            case default
                !write(stdout,*) 'Debug: Unknown line:',trim(adjustl(str))
                continue
        end select                                
    enddo
    ! Check consistency of &Table &EndTable tags
    if  ((cnt_bTable.gt.1) .or. (cnt_eTable.gt.1)) then
        write(stdout,*) 'ERROR: Reading Included RDF : ',trim(IncludeFileName),&
                ': more than one line with tag &Table or &EndTable found '
        stop
    endif
    if (bTable.eq.0) then
        write(stdout,*) 'ERROR: Reading RDF: File: ',trim(IncludeFileName),': Can not find begin of section &Table'
        stop
    endif
    if (eTable.eq.0) then
        write(stdout,*) 'ERROR: Reading RDF: File: ',trim(IncludeFileName),' Can not find end of section &EndTable'
        stop 
    endif
    if (bTable.gt.eTable) then
        write(stdout,*) 'ERROR: Reading RDF: File: ',trim(IncludeFileName),&
                    ': The section &Table starts at line ',bTable, 'and ends at line ',eTable
        stop
    endif         
end subroutine

