subroutine RDFReadPropCommon(text, bRDF, eRDF, PName, PRmin, PRmax, PNPoints, PType,&
                            cnt_N_NB, cnt_N_B, cnt_N_A, bTable, eTable, &
                            FlagZero,FlagTableFound, FlagIncludeFileFound, IncludeFileName, InitPot)
! Global Variables
    character(rdf_text), allocatable :: text(:)
    character(rdf_text) PName,PType
    character(filename_text) IncludeFileName    
    integer bRDF, eRDF, PNPoints, bTable, eTable,cnt_N_NB, cnt_N_B, cnt_N_A, InitPot
    real(8) PRmin, PRmax
    logical FlagTableFound, FlagIncludeFileFound,FlagZero
! Local Variables
    integer  cnt_bTable, cnt_eTable, &
    j,ierr
    character(rdf_text) str,l,field
    
    bTable=0
    eTable=0
    cnt_eTable=0
    cnt_bTable=0
    ! Default values
    FlagZero=.false.
    FlagTableFound=.false.
    FlagIncludeFileFound=.false.
    InitPot=-1 ! Undefined
    do j=bRDF, eRDF
        call ReadLineFromText(text,j,str,ierr)
        l=str
        call split(l,'=',field)        
        select case (uppercase(trim(adjustl(field))))
            case ('NAME')
                PName=trim(adjustl(l))
!                       write(stdout,*) 'Debug: Name:',Pname
            case ('MIN')
                call str2value(trim(adjustl(l)),PRMIN,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading RDF: line:',j,' Can not read the actual value of MIN:',l
                    write(stdout,*) str
                    stop                                                                                                    
                endif
!                      write(stdout,*) 'Debug: RMIN:',Prmin
            case ('MAX')
                call str2value(trim(adjustl(l)),PRMAX,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading RDF: line:',j,' Can not read the actual value of MAX:',l
                    write(stdout,*) str
                    stop                                                                      
                endif
!                       write(stdout,*) 'Debug: RMAX:',Prmax
            case ('NPOINTS')
                call str2value(trim(adjustl(l)),PNPoints,ierr)
                if (ierr.ne.0) then
                    write(stdout,*) 'ERROR: Reading RDF: line:',j,' Can not read the actual value of NPoints:',l
                    write(stdout,*) str
                    stop                
                endif
            case ('TYPE')
                PType=trim(adjustl(l))
!                write(stdout,*) 'Debug Type=',PType
                select case (trim(adjustl(PType)))
                    case ('NB')
                        cnt_N_NB=cnt_N_NB+1
                    case ('B')
                        cnt_N_B=cnt_N_B+1 
                    case ('A')
                        cnt_N_A=cnt_N_A+1
                    case default
                        write(stdout,*) 'Error: line ',j,': Wrong type of the RDF:',&
                                    trim(adjustl(PType)),'    It shall be NB, B or A'                                
                end select 
!                        write(stdout,*) 'Debug: NPOINTS:',PNPOINTS
             case ('&TABLE')
                   FlagTableFound=.true.
                   bTable=j
                   cnt_bTable=cnt_bTable+1                   
            case ('&ENDTABLE')
                   eTable=j
                   cnt_eTable=cnt_eTable+1
            case ('&ZERO')  
                   FlagZero=.true.                   
            case ('&INITZERO')  
                   InitPot=0
            case ('&INITPMF')  
                   InitPot=1                   
            case ('&INCLUDERDF')
                   FlagIncludeFileFound=.true.
                   IncludeFileName=trim(adjustl(l))
                   write(stdout,*) 'Debug: IncludedFileFound:', IncludeFileName                   
            case ('INITPOT')
                   write(stdout,*) 'Debug InitPot=',trim(adjustl(l))
                   select case (uppercase(trim(adjustl(l))))
                       case ('PMF')
                           InitPot=1
                       case ('ZERO')
                           InitPot=0
                       case default
                           write(stdout,*) 'ERROR: Reading RDF: line:',j,&
                                   ' Unknown type of potential initialization:',trim(adjustl(l))
                           stop
                   end select

            case default
                continue !write(stdout,*) 'Debug: Unknown line:',trim(adjustl(str))
        end select                                
    enddo
    !    Set default behavior for initial trial potentials: Zero for NB, PMF for B/A
    if (InitPot.eq.-1) then        
        if (trim(adjustl(PType)).eq.'NB') then
            InitPot=0
        else
            InitPot=1
        endif
    endif
    ! Check consistency of &Table &EndTable tags
    if  ((cnt_bTable.gt.1) .or. (cnt_eTable.gt.1)) then
        write(stdout,*) 'ERROR: Reading RDF: more than one line with tag &Table or &EndTable found '
        stop
    endif
    if (FlagTableFound) then 
        if (bTable.eq.0) then
            write(stdout,*) 'ERROR: Reading RDF: Can not find begin of section &Table'
            stop
        endif
        if (eTable.eq.0) then
            write(stdout,*) 'ERROR: Reading RDF: Can not find end of section &EndTable'
            stop 
        endif
        if (bTable.gt.eTable) then
            write(stdout,*) 'ERROR: Reading RDF: The section &Table starts at line ',bTable, 'and ends at line ',eTable
            stop
        endif    
    endif 
    if (FlagTableFound .and. FlagIncludeFileFound) then
        write(stdout,*) 'ERROR: Reading RDF: Both &Table and &IncludeRDF are present in the RDF definition.'
        stop
    endif
    if (.not.(FlagTableFound .or. FlagIncludeFileFound.or.FlagZero)) then
        write(stdout,*) 'ERROR: Reading RDF: Neither &Table nor &IncludeRDF nor &Zero are found', &
                    'The RDF values are not defined.'
        stop        
    endif    
end subroutine
