subroutine ReadRDF(iFilename, NameMType, NBondMType,AdrSiteMType,NSType, NameSType,&! NA,&
    StateNB_iSjS,StateB_iBond, RDFref_B_riBond, rRDFB_riBond, RDFref_NB_riSjS, Bond_iSjS, & 
    NSiteGroupsInBond, iSiteInBond, jSiteInBond, kSiteInBond,&
    NPoints, RMax, RMin,&
    NPointsRDFB,RMaxRDFB,RMinRDFB)
    ! Global variables
!    integer NA
    real(8)  RMax, RMin, PRmax,PRmin
    real(8), allocatable:: r(:), U(:),RMaxRDFB(:),RMinRDFB(:)
    real(8), allocatable:: RDFref_NB_riSjS(:,:,:),&
            RDFref_B_riBond(:,:), rRDFB_riBond(:,:)
    integer, allocatable:: StateNB_iSjS(:,:), StateB_iBond(:),Bond_iSjS(:,:)
    integer, allocatable :: NSiteGroupsInBond(:), iSiteInBond(:,:), jSiteInBond(:,:), kSiteInBond(:,:),&
            NPointsRDFB(:), &
            NBondMType(:), AdrSiteMType(:)
            
    integer N_NB, N_B, N_A, NPoints, NSType

    character(atom_name_len), allocatable:: NameSType(:) 
    character(mol_name_len) NameMType(:)
    ! Local variables
    character(filename_text) iFilename 
    character(atom_name_len) AtomTypesPairStr(2)
    character(rdf_text) str,l, PName, PType,RDF_FileName
    character(rdf_text), allocatable :: text(:), RDFtext(:)
    integer, allocatable:: AtomPairs(:,:), AtomTriplets(:,:)
    integer iostt, i, ierr, iPoint, iR,&            
             iend, bRDF, eRDF, cnt_N_NB, cnt_N_B, cnt_N_A, iend_RDF_text, bRDF_text, eRDF_text, bTable_text, eTable_text,&
             PNPoints, bTable, eTable, PNPairs, PNTriplets, AtomTypesPair(2),&
             LocalBond, iBond, MolType, NBonds, InitPot, Overhead
    logical FlagTableFound, FlagIncludeFileFound, FlagZero
     
    ! Open the RDF file and scan it  for number of lines (variable iend)
    call GetRDFFileLength(iFilename,iend)
! Allocate array for the file    
    allocate(text(iend), RDFtext(iend))
! Read the file to the array text
    open(unit=4,file=iFilename,status='old',iostat=iostt)
    do i=1, iend
        read(4,'(a)') l
        text(i)=trim(adjustl(l))
    enddo
    close(4)    
    
!Read &General section of the file    
    call RDFReadGeneralSection(text, iend,NSType, NameSType, N_NB, N_B, N_A, NPoints, RMax, RMin)
    if (.not. allocated(RDFref_NB_riSjS)) allocate(RDFref_NB_riSjS(NPoints,NSType,NSType))
    ! Check if number of points in each NB RDF is consistent with value provided in the main input file
!    if (NPoints.ne.NA) then
!        write(stdout,*) 'ERROR: Reading RDF:'
!        write(stdout,*) 'Number of points stated in general section of RDF-file: NPoints=', NPoints, 'differs from'
!        write(stdout,*) 'number of points stated in main input file : NA=', NA
!        stop
!    endif
    ! Read RDFs
    NBonds=sum(NBondMType(:))
    ! Count the actual number of Non-bonded, bonded, and bending angle RDFs
    i=1 
    bRDF=0
    eRDF=0
    cnt_N_NB=0
    cnt_N_B=0
    cnt_N_A=0    
    do while (i.le.iend)
        call ReadLineFromText(text,i,l,ierr)
        ! Indicate presence of &RDF 
        if(uppercase(trim(l))=='&RDF') then ! Found begin of the RDF-section
            ! Find end of the RDF section
            call GetEndOfRDFSection(text,i,iend,bRDF,eRDF)
            ! Read common properties of the RDF
            call RDFReadPropCommon(text, bRDF, eRDF, PName, PRmin, PRmax, PNPoints, PType,&
                            cnt_N_NB, cnt_N_B, cnt_N_A, bTable, eTable,&
                            FlagZero, FlagTableFound, FlagIncludeFileFound, RDF_FileName, InitPot)
            ! Read specific properties of the RDF with respect to the type
            if (FlagIncludeFileFound) then
               call ReadIncludedRDFSection(RDF_FileName, RDFtext, iend_RDF_text, bRDF_text, eRDF_text, bTable_text, eTable_text)                
            else
                RDF_FileName=iFileName
                if (allocated(RDFtext)) deallocate(RDFtext)
                allocate(RDFtext(iend))
                RDFtext(:)=text(:)
                iend_RDF_text=iend
                bRDF_text=bRDF
                eRDF_text=eRDF
                bTable_text=bTable
                eTable_text=eTable
            endif            
            select case (trim(adjustl(PType)))
                case ('NB')
                    call RDFReadPropNB(RDFtext, RDF_Filename, bRDF_text, eRDF_text, NameSType, AtomTypesPairStr, AtomTypesPair,&
                         Rmin, Rmax, PRmin, PRmax, Npoints, PNpoints)                    
                    StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))=IBSet(StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2)),4)
                    if (InitPot.eq.1) then ! If init potential with PMF
                        StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))=IBSet(StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2)),1)                         
                    elseif (InitPot.eq.0) then ! If init potential with zero
                        StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))=IBCLR(StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2)),1)                         
                    endif
                    StateNB_iSjS(AtomTypesPair(2),AtomTypesPair(1))=StateNB_iSjS(AtomTypesPair(1),AtomTypesPair(2))
                    call RDFReadTableCommon(RDFtext, RDF_Filename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN, PType)                        
                    
                    Overhead=NPoints-PNPoints ! Number of first lines where RDF==0, in the core region 
                    do iPoint=1, NPoints
                        if (iPoint.le.Overhead) then 
                            RDFref_NB_riSjS(iPoint,AtomTypesPair(1),AtomTypesPair(2))=0.0                        
                            RDFref_NB_riSjS(iPoint,AtomTypesPair(2),AtomTypesPair(1))=0.0                        
                        else
                            iR=r(iPoint-Overhead)*NPoints/PRMAX+1.1
!                            write(stdout,*) 'Debug: Read RDF: Detecting R,R: i=',iPoint,' iR=', iR 
                            RDFref_NB_riSjS(iR,AtomTypesPair(1),AtomTypesPair(2))=U(iPoint-Overhead)
                            RDFref_NB_riSjS(iR,AtomTypesPair(2),AtomTypesPair(1))=U(iPoint-Overhead)
                        endif
                    enddo                    
                case ('B')
                    call RDFReadPropB(RDFtext,RDF_Filename, bRDF_text, eRDF_text, NameMType,MolType,iBond,NBondMType,AdrSiteMType,&
                        PRmin, PRmax, PNpoints,&
                        Bond_iSjS, NSiteGroupsInBond, iSiteInBond, jSiteInBond, kSiteInBond, iprint, stdout)                                                                              
                    StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),4) 
                    if (InitPot.eq.1) then 
                        StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),1) ! If init potential with PMF
                    elseif (InitPot.eq.0) then ! If init potential with zero
                        StateB_iBond(iBond)=IBCLR(StateB_iBond(iBond),1)
                    endif
                    NPointsRDFB(iBond)=PNPoints
                    RMaxRDFB(iBond)=PRmax
                    RMinRDFB(iBond)=PRmin
                    call reshape2(RDFref_B_riBond,PNPoints,NBonds)
                    call reshape2(rRDFB_riBond,PNPoints,NBonds)
                    call RDFReadTableCommon(RDFtext,RDF_Filename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN, PType)                        
                    do iPoint=1, PNPoints
                        rRDFB_riBond(iPoint,iBond)=r(iPoint)
                        RDFref_B_riBond(iPoint,iBond)=U(iPoint)
                    enddo  
                case ('A')
                    call RDFReadPropA(RDFtext,RDF_Filename,bRDF_text,eRDF_text, NameMType, MolType,iBond, NBondMType,AdrSiteMType,&
                        PRmin, PRmax, PNpoints,&
                        Bond_iSjS, NSiteGroupsInBond, iSiteInBond, jSiteInBond, kSiteInBond, iprint, stdout)
                    StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),4)
                    if (InitPot.eq.1) then 
                        StateB_iBond(iBond)=IBSet(StateB_iBond(iBond),1) ! If init potential with PMF
                    elseif (InitPot.eq.0) then ! If init potential with zero
                        StateB_iBond(iBond)=IBCLR(StateB_iBond(iBond),1)
                    endif                 
                    NPointsRDFB(iBond)=PNPoints
                    RMaxRDFB(iBond)=PRmax
                    RMinRDFB(iBond)=PRmin
                    call reshape2(RDFref_B_riBond,PNPoints,NBonds)
                    call reshape2(rRDFB_riBond,PNPoints,NBonds)
                    call RDFReadTableCommon(RDFtext,RDF_Filename, bTable_text, eTable_text, r, U, PNPoints, PRMAX, PRMIN, PType)                        
                    do iPoint=1, PNPoints
                        rRDFB_riBond(iPoint,iBond)=r(iPoint)
                        RDFref_B_riBond(iPoint,iBond)=U(iPoint)
                    enddo  

            end select 
            if (iprint.ge.8) &
                write(stdout,*) 'Debug: RDF Name:', trim(PNAME),', MIN:',PRMIN,', MAX:', PRMAX, ', NPoints:', PNPoints,&
                ', AtomTypes:', trim(AtomTypesPairStr(1)),',',trim(AtomTypesPairStr(2))              
            ! Check if a RDF-table of included-RDF is found
            ! Read the table with RDF points                        
        endif        
        i=i+1
    enddo ! Loop over all the RDFs    
    if (cnt_N_NB.ne.N_NB) then
        write(stdout,*) 'ERROR: Reading RDF:'
        write(stdout,*) 'Number of actual INTERmolecular (NB) RDFs read ', cnt_N_NB, 'differs from'
        write(stdout,*) 'number stated in General section of the rdf file : N_NB=', N_NB
        stop
    endif
        if (cnt_N_B.ne.N_B) then
        write(stdout,*) 'ERROR: Reading RDF:'
        write(stdout,*) 'Number of actual INTRAmolecular pairwise bond length distributions (B) read ', cnt_N_B, 'differs from'
        write(stdout,*) 'number stated in General section of the rdf file : N_B=', N_B
        stop
    endif
    if (cnt_N_A.ne.N_A) then
        write(stdout,*) 'ERROR: Reading RDF:'
        write(stdout,*) 'Number of actual INTRAmolecular angles distributions (A) read ', cnt_N_A, 'differs from'
        write(stdout,*) 'number stated in General section of the rdf file : N_A=', N_A
        stop
    endif
    cnt_N_B=0
    cnt_N_A=0    

end subroutine
