subroutine MCmodStep( NAtom, NA, MTypeMol,MolAtom, STypeAtom, NPointsPotB,&
         NKV, iPrint, stdout,LMoveMType,MCStepAtomMType, ChargeAtom, BOX, RCUT, RECUT, RMAX, ALPHA, COULF,&
        PotNB_riSjS, PotB_riBond, RMaxPotB, RMinPotB,SSIN, SCOS,ENER,EEL,EINT,EINT_ang, Svec,Recvec, RKV,AccCntMType )
    use utilsmod
    use timer
    implicit none
!-------Global Variables--------------------
    integer(4), intent(in):: NAtom, NA, MTypeMol(:),MolAtom(:), STypeAtom(:), NPointsPotB(:),&
         NKV, iPrint, stdout
    logical, intent(in):: LMoveMType(:)
    real(8), intent(in):: MCStepAtomMType(:), ChargeAtom(:), BOX(3), RCUT, RECUT, RMAX, ALPHA, COULF,&
        PotNB_riSjS(:,:,:), PotB_riBond(:,:), RMaxPotB(:), RMinPotB(:)         
    real(8), intent(inout) :: SSIN(:), SCOS(:),ENER,EEL,EINT,EINT_ang, Svec(:,:),Recvec(:,:), RKV(:)
    integer(8), intent(inout):: AccCntMType(:,:)
!-------Local Variables---------------------    
    integer(4) iAtom, N, ikv, iMType
    logical lExit
    real(8) R(3), DDE, DE, DEE, DEW, DDI, DDI_ANG, deltaR(3), DES
    
    !  Choice of trial particle
    do
        iAtom=NAtom*rand()+1
        iMType=MTypeMol(MolAtom(iAtom))
        if(LMoveMType(iMType)) exit
    enddo
    AccCntMType(iMType,2)=AccCntMType(iMType,2)+1 ! Count trial step for the molecular type
    ! Calculate random displacement vector and new coordinates of the atom
    deltar=[MCStepAtomMType(iMType)*(rand()-0.5d0),MCStepAtomMType(iMType)*(rand()-0.5d0),MCStepAtomMType(iMType)*(rand()-0.5d0)]
    R=Svec(:,iAtom)+deltaR
    call MCPBC(R,BOX)
    call TimerStart(T_MCStepdE)
    call MCmodNewStep(NAtom, iAtom, deltaR, RCUT,RECUT, RMAX, ALPHA, COULF, ChargeAtom, STypeAtom,BOX, NA,POTNB_riSjS,&
        MolAtom, NPointsPotB, RMaxPotB, RMinPotB, PotB_riBond, stdout, Lexit)
    call TimerStop(T_MCStepdE)
    if (.not. LEXIT) then
        ! Calculate energy component differences
        DDE=sum(Eij_new,mask=MaskNB(:,iAtom))      -  sum(Eij(:,iAtom),mask=MaskNB(:,iAtom))
        DEE=sum(Eelij_new,mask=MaskNB(:,iAtom))      -  sum(Eelij(:,iAtom),mask=MaskNB(:,iAtom))
	DES=sum(Eelij_new,mask=(MaskB(:,iAtom).or.MaskA(:,iAtom))) -  sum(Eelij(:,iAtom),mask=MaskB(:,iAtom).or.MaskA(:,iAtom))!DEE
        DDI=sum(Eij_new,mask=MaskB(:,iAtom))       -  sum(Eij(:,iAtom),mask=MaskB(:,iAtom))  !DDI
        DDI_ang=sum(Eang_new)-sum(Angles(AngAtom(1:NAngAtom(iAtom),iAtom))%Eang,mask=Angles(AngAtom(1:NAngAtom(iAtom),iAtom))%LMove)
        !  Corrections due to electrostatics
        if(ChargeAtom(iAtom).ne.0.d0) then            
            call TimerStart(T_DifEw)
            call MCmodDifEw(R,ChargeAtom(iAtom),DEW,Recvec,RKV,SSIN,SCOS,NKV,Svec(:,iAtom))                        
            call TimerStop(T_DifEw)
	else
	    DEW=0.0
        endif
    	DE=DDI+DDE+DEE+DES+DEW+DDI_ang
!  MC transition
      	if(DE.gt.0.0)then
            if(DE.gt.18.d0)return
            if(dexp(-DE).lt.rand())return
      	end if
!  New configuration
        Svec(:,iAtom)=R
      	ENER=ENER+DE
        EEL=EEL+DEW+DEE+DES
        EINT=EINT+DDI
        EINT_ang=EINT_ang+DDI_ang
      	AccCntMType(iMType,1)=AccCntMType(iMType,1)+1
       	if(ChargeAtom(iAtom).ne.0.d0) then
            SSIN=SSIN+D_SIN
            SCOS=SCOS+D_COS
        endif
        
        ! Update arrays
        !Pairwise Non-bonded, electrostatics and Pair bonds
        Rij_vec(:,:,iAtom)  = Rij_vec_new  ! vector of interparticle distances
        Rij_vec(:,iAtom,:)  = -Rij_vec_new
        Rij(:,iAtom)        = Rij_new ! interparticle distance
        Rij(iAtom,:)        = Rij_new
        Ri_vec(:,iAtom)     =  Ri_vec(:,iAtom)+deltaR
        
        Eij(:,iAtom)      = Eij_new
        Eij(iAtom,:)      = Eij_new
        Eelij(:,iAtom)      = Eelij_new ! Electrostatic direct space energy term
        Eelij(iAtom,:)      = Eelij_new
        
        VIRij(:,iAtom)    = VIRij_new
        VIRij(iAtom,:)    = VIRij_new 
        ! Angle-bending, side
        N=NAngAtom(iAtom)
        if (N.gt.0) then
            Angles(AngAtom(1:N,iAtom))%Eang=Eang_new(1:N)
            Angles(AngAtom(1:N,iAtom))%Phi=Phi_new(1:N)
        endif        
        
!        if (maxval(abs(Svec(:,iAtom))).gt.BOX(1)) then
!            write(*,*) 'DEBUG: MCStep: Atom beyond box: S:',Svec(:,iAtom)
!            stop
!        endif
    endif
    return
end subroutine!MCStep

!==================== MCTrans =======================================

subroutine MCmodTrans(MCTransStepMType, RCUT, RECUT, RMAX, ALPHA, COULF, BOX,&
        Recvec,RKV,SSIN,SCOS,ChargeAtom,POTNB_riSjS,&
        NAtom,NMol,NA, NSiteMType,MTypeMol,AdrAtomMol,STypeAtom, NKV, iPrint, stdout,&
        LMoveMType,Ener, EEL,Svec,AccCntMType)
    use utilsmod
    implicit none
!-------Global Variables--------------------
    real(8), intent(in) :: MCTransStepMType(:), RCUT, RECUT, RMAX, ALPHA, COULF, BOX(3),&
        Recvec(:,:),RKV(:),ChargeAtom(:),POTNB_riSjS(:,:,:)
    integer(4), intent(in):: NAtom,NMol,NA, NSiteMType(:),MTypeMol(:),AdrAtomMol(:),STypeAtom(:), NKV,&
            iPrint, stdout
    logical, intent(in):: LMoveMType(:)
    real(8), intent(inout):: Ener, EEL, SSIN(:), SCOS(:),Svec(:,:)
    integer(8), intent(inout) :: AccCntMType(:,:)
!-------Local Variables---------------------
    real(8) DE,DDE,DEE,DEW, deltarand(3)
    real(8), allocatable:: S_new(:,:)
    integer(4) NAtomsInMol, iMol, j, jj, nchatom, iAtom
    integer(4),allocatable:: ichatomlist(:,:)    

    !  Choice of trial Molecule
    do
        iMol=NMol*rand()+1
        NAtomsInMol=NSiteMType(MTypeMol(iMol)) ! Number of atoms in the selected molecule
	if(LMoveMType(MTypeMol(iMol)).and.(NAtomsInMol.gt.1)) exit
    enddo    
    AccCntMType(MTypeMol(iMol),2)=AccCntMType(MTypeMol(iMol),2)+1! Count trial step
    allocate(S_new(3,NAtomsInMol),ichatomlist(NAtomsInMol,2)) ! Array of shifted coordinates of the selected molecule.
    S_new(:,:)=0.d0
    
    nchatom=0
  ! Trial shift
    deltarand= [(rand()-0.5d0), (rand()-0.5d0), (rand()-0.5d0)]*MCTransStepMType(MTypeMol(iMol))
    if (IPRINT.gt.7) write((stdout),*) 'MCTrans trans: Ich,Q,    Xo,     Yo,     Zo,     Xn,    Yn,    Zn'
    do J=1,NAtomsInMol  ! Forming array of shifted coordinates
        JJ=AdrAtomMol(iMol)+J ! Global atom number of J-th atom in the molecule
        S_new(:,J)=Svec(:,jj)+deltarand
        if(ChargeAtom(JJ).ne.0.d0) then
            nchatom=nchatom+1
            ichatomlist(nchatom,1)=J ! Atom number in the molecule
            ichatomlist(nchatom,2)=JJ ! Global atom number
            if (IPRINT.gt.7)write((stdout),'(a,i5,7f9.4)') 'MCTrans Trans:',nchatom,ChargeAtom(JJ),Svec(:,JJ),S_new(:,J)
        endif
    enddo
    
!  Energy difference
    call MCmodNewTrans(NAtom, iMol, deltaRand, RCUT,RECUT, RMAX, ALPHA, COULF, ChargeAtom, STypeAtom,Box,NA, POTNB_riSjS,&
    NSiteMType, MTypeMol,AdrAtomMol, stdout)
    
    ! Calculate energy component differences
    DDE=sum(EijM_new(:,1:NAtomsInMol),mask=MaskNB(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1))) -  &
                sum(Eij(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1)),mask=MaskNB(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1))) ! Short range
    DEE=sum(EelijM_new(:,1:NAtomsInMol),mask=MaskNB(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1)))- &
                sum(Eelij(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1)),mask=MaskNB(:,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1))) ! Direct el-statics    
    call MCmodDIFEWM(AdrAtomMol,iMol,Recvec,RKV,SSIN,SCOS,Svec,NKV,S_new,ChargeAtom,DEW)                        
    DE=DDE+DEE+DEW ! Total energy difference
                
    if (IPRINT.gt.7) write((stdout),*)' MCTrans trans: iMol, DE, DDE, DEE, DEW',iMol,DE,DDE,DEE,DEW
    if(DE.gt.0)then
        if(DE.gt.18.d0) then
            deallocate(S_new,ichatomlist)
            return
        endif
        if(dexp(-DE).lt.rand())then 
            deallocate(S_new,ichatomlist)
            return
        endif
    end if
!  New configuration saving
    Svec(1:3,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1))=S_new(1:3,1:NAtomsInMol)
    ! Update arrays
        !Pairwise Non-bonded, electrostatics and Pair bonds
    forall (iAtom=1:NAtomsInMol)
        Rij_vec(:,:,AdrAtomMol(iMol)+iAtom)  = RijM_vec_new(:,:,iAtom)  ! vector of interparticle distances
        Rij_vec(:,AdrAtomMol(iMol)+iAtom,:) = -RijM_vec_new(:,:,iAtom)
        Rij(:,AdrAtomMol(iMol)+iAtom)        = RijM_new(:,iAtom) ! interparticle distance
        Rij(AdrAtomMol(iMol)+iAtom,:)        = RijM_new(:,iAtom)
        Ri_vec(:,AdrAtomMol(iMol)+iAtom)     = Ri_vec(:,AdrAtomMol(iMol)+iAtom)+deltarand
        
        Eij(:,AdrAtomMol(iMol)+iAtom)      = EijM_new(:,iAtom)
        Eij(AdrAtomMol(iMol)+iAtom,:)      = EijM_new(:,iAtom)
        Eelij(:,AdrAtomMol(iMol)+iAtom)      = EelijM_new(:,iAtom) ! Electrostatic direct space energy term
        Eelij(AdrAtomMol(iMol)+iAtom,:)      = EelijM_new(:,iAtom)
        
        VIRij(:,AdrAtomMol(iMol)+iAtom)        = VIRijM_new(:,iAtom) ! interparticle distance
        VIRij(AdrAtomMol(iMol)+iAtom,:)        = VIRijM_new(:,iAtom)
    end forall
    ENER=ENER+DE
    EEL=EEL+DEE+DEW
    AccCntMType(MTypeMol(iMol),1)=AccCntMType(MTypeMol(iMol),1)+1!
    if (IPRINT.gt.7) write((stdout),*) "MCTrans trans: ENER=",ENER," DE=",DE
    SSIN=SSIN+sigmasin
    SCOS=SCOS+sigmacos
    deallocate(s_new,ichatomlist)
    return
end subroutine

!==================== MCRot =======================================
subroutine MCmodRot(NAtom,NA,NKV,NMol,IPRINT,stdout,NSiteMType,MTypeMol,AdrAtomMol,STypeAtom,SiteAtom,&
            BOX,MCRotStepMType,RCUT,RMAX,RECUT,COULF,ALPHA,&
            ChargeAtom,MassSite,SumMassMType,PotNB_riSjS,LMoveMType,&
            Recvec,RKV,&
            Svec,Wvec,XvecCOMMol,SSIN,SCOS,ENER,EEL,EINT,AccCntMType)
    use utilsmod
    implicit none
!-------Global Variables--------------------
    real(8), intent(in):: BOX(3),MCRotStepMType(:),RCUT,RMAX,RECUT,COULF,ALPHA,&
            ChargeAtom(:),MassSite(:),SumMassMType(:),PotNB_riSjS(:,:,:),&
            Recvec(:,:),RKV(:)
    real(8), intent(inout):: Svec(:,:),Wvec(:,:),XvecCOMMol(:,:),SSIN(:),SCOS(:),ENER,EEL,EINT
    integer(4), intent(in):: NAtom,NA,NKV,NMol,IPRINT,stdout,NSiteMType(:),MTypeMol(:),AdrAtomMol(:),STypeAtom(:),SiteAtom(:)
    integer(8), intent(inout):: AccCntMType(:,:)
    logical, intent(in):: LMoveMType(:)
!-------Local Variables---------------------
    real(8) DDE,DEE,DEW, ran,DE
    real(8), allocatable:: S_new(:,:), W_New(:,:), deltaR(:,:)
    integer(4) J,JST,NAtomsInMol,JJ,nchatom,K,kk, iMol, iAtom, ibeg, iend
    
    integer(4),allocatable:: ichatomlist(:,:)
    real(8) phi, x1,y1,z1

!  Choice of trial Molecule
    do
        iMol=NMol*rand()+1
        NAtomsInMol=NSiteMType(MTypeMol(iMol)) ! Number of atoms in the selected molecule
        if(LMoveMType(MTypeMol(iMol)).and.(NAtomsInMol.gt.1)) exit
    enddo
    AccCntMType(MTypeMol(iMol),2)=AccCntMType(MTypeMol(iMol),2)+1! Count trial step
!  Calculate the COM of the molecule, keeping the bonds whole with respect to PBC
    call MCgetCOM(iMol, MTypeMol,MassSite,SumMassMType, Wvec,box,AdrAtomMol,SiteAtom,XvecCOMMol)
! Trial rotation generation
    call RanRotVec(x1,y1,z1)
    phi=rand()*2*3.141592653d0*MCRotStepMType(MTypeMol(iMol))
! Trial coordinates
    call MCmodNewRot(NAtom, iMol, [x1,y1,z1],phi, RCUT,RECUT, RMAX, ALPHA, COULF, ChargeAtom, STypeAtom, BOX,&
    NA, POTNB_riSjS, NSiteMType, MTypeMol,AdrAtomMol, SumMassMType, MassSite, SiteAtom, stdout)
    
    allocate(S_new(3,NAtomsInMol),ichatomlist(NAtomsInMol,2)) ! Array of shifted coordinates of the selected molecule.
    S_new(:,:)=0.d0
    allocate(W_new(3,NAtomsInMol)); W_new=0.0
    allocate(deltaR(3,NAtomsInMol)); deltaR=0.0
    ichatomlist(:,:)=0
    nchatom=0
  ! Trial rotaton
    if (IPRINT.gt.7) write((stdout),*) 'MCRot: Ich,Q,    Xo,     Yo,     Zo,     Xn,    Yn,    Zn'
    do J=1,NAtomsInMol  ! Forming array of shifted coordinates
        JJ=AdrAtomMol(iMol)+J ! Global atom number of J-th atom in the molecule
        W_new(:,j)=Wvec(:,jj)
        call rotate2(w_new(1,J),W_new(2,J),w_new(3,J),phi,x1,y1,z1) ! Rotating atoms around center of MassSite of their molecule       
        S_new(:,j)=XvecCOMMol(:,imol)+W_new(:,J) !Convert to system-wide coordinates (add COM-coordinates)
        deltaR(:,J)=W_new(:,j)-Wvec(:,jj)![WX(JJ), WY(JJ), WZ(JJ)]
        if(ChargeAtom(JJ).ne.0.d0) then
            nchatom=nchatom+1
            ichatomlist(nchatom,1)=J ! Atom number in the molecule
            ichatomlist(nchatom,2)=JJ! Global atom number
            if (IPRINT.gt.7) write((stdout),'(a,i5,7f9.4)')'MCRot:',nchatom,ChargeAtom(JJ),Svec(:,JJ),S_new(:,J)
        endif
    enddo 
! Energy contributions
    ibeg=AdrAtomMol(iMol)+1
    iend=AdrAtomMol(iMol+1)
! Energy change
    DDE=sum(EijM_new(:,1:NAtomsInMol),mask=MaskNB(:,ibeg:iend)) - sum(Eij(:,ibeg:iend),mask=MaskNB(:,ibeg:iend))
    DEE=sum(EelijM_new(:,1:NAtomsInMol),mask=MaskNB(:,ibeg:iend))-sum(Eelij(:,ibeg:iend),mask=MaskNB(:,ibeg:iend))
! Correction due to double count of interactions within the same molecule
    DDE=DDE-0.5*(sum(EijM_new(ibeg:iend,1:NAtomsInMol),mask=MaskNB(ibeg:iend,ibeg:iend))-&
	sum(Eij(ibeg:iend,ibeg:iend),mask=MaskNB(ibeg:iend,ibeg:iend)))  !DDE 
    DEE=DEE-0.5*(sum(EelijM_new(ibeg:iend,1:NAtomsInMol),mask=MaskNB(ibeg:iend,ibeg:iend))-&
	sum(Eelij(ibeg:iend,ibeg:iend),mask=MaskNB(ibeg:iend,ibeg:iend)) )
!  Corrections due to Ewald electrostatics
    call MCmodDIFEWM(AdrAtomMol,iMol,Recvec,RKV,SSIN,SCOS,Svec,NKV,S_new,ChargeAtom,DEW)                        
    DE=DDE+DEE+DEW ! Total energy difference
!  MC transition
    ran=rand()
    if (DE.gt.500) DE=500.0
    if ((DE.lt.0).or.(dexp(-DE).gt.ran)) then ! If accepted
        do J=1,NAtomsInMol
            JJ=AdrAtomMol(iMol)+J
            Wvec(:,JJ)=S_new(:,j)-XvecCOMMol(:,imol)
	    call MCPBC(S_new(1:3,j),BOX)
        enddo
        Svec(1:3,AdrAtomMol(iMol)+1:AdrAtomMol(iMol+1))=S_new(1:3,1:NAtomsInMol)

        AccCntMType(MTypeMol(iMol),1)=AccCntMType(MTypeMol(iMol),1)+1
        ENER=ENER+DE
        EINT=EINT
        EEL=EEL+DEE+DEW
        ! Update arrays
        !Pairwise Non-bonded, electrostatics and Pair bonds
        forall (iAtom=1:NAtomsInMol)
            Rij_vec(1:3,1:NAtom,AdrAtomMol(iMol)+iAtom)  = RijM_vec_new(1:3,1:NAtom,iAtom)  ! vector of interparticle distances
            Rij_vec(1:3,AdrAtomMol(iMol)+iAtom,1:NAtom) = -RijM_vec_new(1:3,1:NAtom,iAtom)
            Rij(1:NAtom,AdrAtomMol(iMol)+iAtom)        = RijM_new(1:NAtom,iAtom) ! interparticle distance
            Rij(AdrAtomMol(iMol)+iAtom,1:NAtom)        = RijM_new(1:NAtom,iAtom)
            Ri_vec(:,AdrAtomMol(iMol)+iAtom)           = Ri_vec(:,AdrAtomMol(iMol)+iAtom)+deltaR(:,iAtom)

            Eij(:,AdrAtomMol(iMol)+iAtom)      = EijM_new(:,iAtom)
            Eij(AdrAtomMol(iMol)+iAtom,:)      = EijM_new(:,iAtom)
            Eelij(:,AdrAtomMol(iMol)+iAtom)      = EelijM_new(:,iAtom) ! Electrostatic direct space energy term
            Eelij(AdrAtomMol(iMol)+iAtom,:)      = EelijM_new(:,iAtom)
            
            VIRij(1:NAtom,AdrAtomMol(iMol)+iAtom)        = VIRijM_new(1:NAtom,iAtom) 
            VIRij(AdrAtomMol(iMol)+iAtom,1:NAtom)        = VIRijM_new(1:NAtom,iAtom)
        end forall
        if (IPRINT.ge.7) write((stdout),'(a,i5,5f10.7)')'MCRot:iMol,DE,DDE,DEE,DEW ',iMol,DE,DDE,DEE,DEW
        if (IPRINT.gt.7) write((stdout),*) "MCRot: ENER=",ENER," DE=",DE
        SSIN=SSIN+sigmasin
        SCOS=SCOS+sigmacos
    endif
    deallocate(S_new,ichatomlist)
    return
end subroutine
