subroutine MCCorrel(NAtom, STypeAtom, NPointsPotB,IndexGlobB_riBond,IndexGlobNB_risjs,&  
    RCUT,RMinPotB, RMaxPotB, LIMC,Bond_isjs,SiteAtom, CORS, CORP, NAV, npairsrdf)
    ! Subroutine calculating Sij, and cross-correlators
    implicit none
    integer(4), intent(in):: NAtom, &
         STypeAtom(:),  NPointsPotB(:), &
        IndexGlobB_riBond(:,:),IndexGlobNB_risjs(:,:,:), BOnd_isjs(:,:), SiteAtom(:)  
    real(8), intent(in):: RCUT,RMinPotB(:), RMaxPotB(:)
    logical, intent(in):: LIMC
    integer(8), intent(inout), allocatable:: CORS(:), CORP(:,:)
    integer(4), intent(inout):: NAV
    integer(8), intent(inout):: npairsrdf(:,:)    
    
    integer(4) iAtom, jAtom, iBond, NR, nphi, iAngle, i, j, iSType,jSType
    type(Angle) :: A
    integer(8), allocatable::  CCOR(:)

    allocate(CCOR(size(CORS)))   
    CCOR(:)=0        
    ! Treat Non-bonded pairs
    do iAtom=1, NAtom
        iSType=STypeAtom(iAtom)
        do jAtom=iAtom+1, NAtom
            jSType=STypeAtom(jAtom)
            if (MaskNB(jAtom,iAtom).and.(AdrGlobIndexAtomij(jAtom,iAtom).ge.0)) then
                if(Rij(jAtom,iAtom).le.RCUT) then
                    NR=Rij(jAtom,iAtom)/RDFINC+1
                    CCOR(AdrGlobIndexAtomij(jAtom,iAtom)+NR)=CCOR(AdrGlobIndexAtomij(jAtom,iAtom)+NR)+1
                    if (IndexGlobNB_riSjS(NR,jSType,iSType).ne.AdrGlobIndexAtomij(jAtom,iAtom)+NR) then
                        write(*,*)'MCCorrel NB:', IndexGlobNB_riSjS(NR,jSType,iSType),AdrGlobIndexAtomij(jAtom,iAtom)+NR,&
                            NR, iSType, jstype, jAtom, iatom
                            stop
                    endif
                else
                    npairsrdf(jSType,iSType)=npairsrdf(jSType,iSType)+1
                endif                
            endif
        enddo
    enddo
    
    do iAtom=1,NAtom
        do i=1,NBondsAtom(iAtom)
            iBond=BondNum(i,iAtom)
            jAtom=jAtomBond(i,iAtom)
            if (MaskB(jAtom,iAtom).and.(jAtom.gt.iAtom)) then 
                NR=(Rij(jAtom,iAtom)-RMinPotB(iBond))*NPointsPotB(iBond)/(RMaxPotB(iBond)-RMinPotB(iBond))+1.
                CCOR(AdrGlobIndexAtomij(jAtom,iAtom)+NR)=CCOR(AdrGlobIndexAtomij(jAtom,iAtom)+NR)+1
                if (IndexGlobB_riBond(NR,iBond).ne.AdrGlobIndexAtomij(jAtom,iAtom)+NR) &
                            write(*,*)'MCCorrel B:', IndexGlobB_riBond(NR,iBond),AdrGlobIndexAtomij(jAtom,iAtom)+NR,&
                            NR, iBOnd, bond_isjs(SiteAtom(iAtom),SiteAtom(jAtom)), jAtom, iAtom,SiteAtom(iAtom),SiteAtom(jAtom)
            endif
        enddo
    enddo
    ! Treat covalent angle bond interactions
    do iAngle=1, NAngles
        A=Angles(iAngle)
        Nphi=(A%phi-RMinPotB(A%Bond))*NPointsPotB(A%Bond)/(RMaxPotB(A%Bond)-RMinPotB(A%Bond))+1.
        if (A%LMove) CCOR(IndexGlobB_riBond(Nphi,A%Bond))=CCOR(IndexGlobB_riBond(Nphi,A%Bond))+1
    enddo    
    !  correlators           CCOR(I) = S_alpha   (alpha = I)    
    CORS=CORS+CCOR
    if(LIMC) then 
        do I=1,size(CORS) ! Over all points of joint potential
            if(CCOR(i).ne.0.d0) then ! if             
                do J=I,size(CORS) ! 
                    CORP(J,I)=CORP(J,I)+CCOR(i)*CCOR(J)     !  S_alpha * S_gamma
	    	end do
            end if	
        end do
    end if

    NAV=NAV+1
    deallocate(CCOR)    
end subroutine

subroutine MCEnergy(ENER, EINT, EINT_ang, EEL, EFUR,ESF, iPrint, stdout)
    implicit none
    integer(4), intent(in):: iPrint, stdout
    real(8), intent(inout):: ENER, EINT, EINT_ang, EEL, EFUR , ESF   
    real(8) ENER_old, EINT_old, EINT_ang_old, EEL_old, EFUR_old, EFCOR, DE, DEE, DES
    
    
    ENER_old=ENER; EINT_old=EINT; EINT_ang_old=EINT_ang;  EEL_old=EEL; EFUR_old=EFUR
    
    DE=sum(Eij, mask=MaskNB)/2.0+ENB_frozen
    EINT=sum(Eij, mask=MaskB)/2.0+EB_frozen
    EINT_ang=sum(Angles(:)%Eang,mask=Angles(:)%LMove)+EA_frozen
    DEE=sum(Eelij,mask=MaskNB)/2.0+EelNB_frozen
    DES=sum(Eelij,mask=(MaskB.or.MaskA))/2.0 +EelBA_frozen
    
            
    EEL=ESF+EFUR+DEE+DES
    ENER=EEL+DE+EINT+EINT_ang
    EFCOR=ESF+EFUR+DES
    if((dabs(ENER_old-ENER).gt.0.01).and.(iPrint.ge.5)) then
        write((stdout),'(2(a,f14.5))') 'MCENERGY: Error in energy: was ',ENER_old*FKJM,' now ',ENER*FKJM
        write((stdout),'(2a)') '                  ', &
            'Etotal          Eel         Ebond           Eang           Efurier        Eelself      '
        write((stdout),'(a15,6f14.6)') 'Before Energy:',ENER_old*FKJM,EEL_old*FKJM,EINT_old*FKJM,EINT_ang_old*FKJM,&
                                        EFUR_old*FKJM,ESF*FKJM
        write((stdout),'(a15,6f14.6)') 'After Energy:',ENER*FKJM,EEL*FKJM,EINT*FKJM,EINT_ang*FKJM,EFUR*FKJM,ESF*FKJM
    endif
            
    if(IPRINT.ge.7)then
        write((stdout),*)'*** ENERGY components and (non-frozen part)***'
        write((stdout),*)' total:         ',ENER*FKJM,'(',(ENER-ENB_frozen-EB_frozen-EA_frozen-EelNB_Frozen-EelBA_frozen)*FKJM,')'
        write((stdout),*)' short range:   ',DE*FKJM, '(',(DE-ENB_frozen)*FKJM,')'   
        write((stdout),*)' electrostatic: ',EEL*FKJM,'(',(EEL-EelNB_Frozen-EelBA_frozen)*FKJM,')'
        write((stdout),*)' pairwise bonds:',EINT*FKJM,'(',(EINT-EB_frozen)*FKJM,')'
        write((stdout),*)' angle bonds:    ',EINT_ang*FKJM,'(',(EINT_ang-EA_frozen)*FKJM,')'
        write((stdout),*)' real Ew:       ',DEE*FKJM,'(',(DEE-EelNB_Frozen)*FKJM,')'
        write((stdout),*)' Fourier:       ',EFUR*FKJM
        write((stdout),*)' self-mol:      ',DES*FKJM,'(',(DES-EelBA_Frozen)*FKJM,')'
        write((stdout),*)' Ewald self-int:',ESF*FKJM
        write((stdout),*)' Ewald self-mol:',(ESF+DES)*FKJM
        write((stdout),*)' tot Ew.corr:   ',EFCOR*FKJM
    end if
end subroutine

