subroutine MCmodInit(NA,RMAX,NMType,NAtom,NBond,NMolMType, NBondMType,MTypeBond,NSiteMType,SiteAtom, Bond_iSjS, MolAtom, BtypeBond,&
        AdrAtomMol,AdrBondMType,AdrSiteMType, iSiteInBond,jSiteInBond,kSiteInBond,NSiteGroupsInBond,StateNB_iSjS,StateB_iBond,&
        STypeAtom,AccCntMType,&
        iPrint,stdout)
        
    implicit none
    integer(4), intent(in) :: NA, NAtom,NBond, NMolMType(:), NBondMType(:),MTypeBond(:), NSiteMType(:),SiteAtom(:),STypeAtom(:),&
                            Bond_iSjS(:,:), MolAtom(:), BTypeBond(:),StateNB_iSjS(:,:),StateB_iBond(:),&
                                NMType, stdout, iPrint, AdrAtomMol(:),AdrBondMType(:), AdrSiteMType(:), &
                                iSiteInBond(:,:),jSiteInBond(:,:),kSiteInBond(:,:), NSiteGroupsInBond(:)     
    real(8), intent(in) :: RMAX
    integer(8),allocatable:: AccCntMType(:,:,:)

    integer(4) iAtom, jAtom, kAtom, jSite, kSite, jBond, MAxBonds, i, iNBond, iMol, iMType, iBond, igrp, mol,NAtomsInMol
    type(angle) iAngle

    ! Set default values, allocate arrays
    RDFINC=RMAX/NA        
    call reshape3(Rij_vec,3,NAtom,NAtom)
    call reshape2(Rij,NAtom, NAtom); call reshape2(VIRij,NAtom, NAtom)
    call reshape2(Eij,NAtom, NAtom); call reshape(Eij_new,NAtom)        
    call reshape2(Eelij,NAtom, NAtom); call reshape(Eelij_new,NAtom)        
    call reshape2(Rij_vec_new,3,NAtom); Rij_vec_new=0.0
    call reshape(Rij_new,NAtom); Rij_new=0.0
    call reshape(VIRij_new,NAtom); VIRij_new=0.0
    call reshape2(Ri_vec,3,NAtom)
    NAtomsInMol=MaxVal(NSiteMType(1:NMType))
    call reshape2(EijM_new, NAtom, NAtomsInMol)
    call reshape2(EelijM_new, NAtom,NAtomsInMol)
    call reshape2(RijM_new, NAtom, NAtomsInMol); call reshape2(VIRijM_new, NAtom, NAtomsInMol)
    call reshape3(RijM_vec_new,3,NAtom,NAtomsInMol)
    call reshape3(AccCntMType,NMType,2,3)
    AccCntMType(1:NMType,2,1:3)=1 ! initialize with 1-s to prevent division by zero error
!  Pairwise Bond part ------------------
    MaxBonds=maxval(count(Bond_isjs(:,:).ne.0,1)) ! Returns maximum number of bonds a single atom in involved in
    if (iPrint.ge.8) write(stdout,*) 'MCmodInit MaxBonds:', MaxBonds
    if (MaxBonds.eq.0)  MaxBonds=1 ! 1 if no bond are present. Allocate dummy arrays
    call reshape(NBondsAtom, NAtom)
    call reshape2(BondNum, MaxBonds, NAtom)
    call reshape2(jAtomBond, MaxBonds, NAtom)
    do iAtom=1,NAtom
        NBondsAtom(iAtom)=count(BTypeBond(pack(Bond_iSjS(:,SiteAtom(iAtom)),Bond_iSjS(:,SiteAtom(iAtom)).ne.0)).eq.1)
        BondNum(1:NBondsAtom(iAtom),iAtom)=pack(pack(Bond_iSjS(:,SiteAtom(iAtom)),Bond_iSjS(:,SiteAtom(iAtom)).ne.0),&
                                BTypeBond(pack(Bond_iSjS(:,SiteAtom(iAtom)),Bond_iSjS(:,SiteAtom(iAtom)).ne.0)).eq.1)
    enddo        
    do iAtom=1,NAtom
        jBond=0
        do jAtom=1,NAtom
            if ((MolAtom(iAtom).eq.MolAtom(jAtom)).and.(Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom)).ne.0)) then
                if (BTypeBond(Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom))).eq.1) then
                    jBond=jBond+1
                    jAtomBond(jBond,iAtom)=jAtom
                endif
            endif
        enddo
    enddo
    
! Angle-bond part-----------------------------------------------------
    ! Count total number of angle-bonds present in the system: i
    NAngles=0
    do iBond=1, NBond
        if (BTypeBond(iBond).eq.2) NAngles=NAngles+NSiteGroupsInBond(iBond)*NMolMType(MTypeBond(iBond))
    enddo
    if (iPrint.ge.8) write(stdout,*) 'MC init: Total number of angle-bonds:',NAngles        
    
    allocate(angles(max(NAngles,1))) ! Array of a-bonds 
    ! Assign atoms and bonds to the allocated angles
    i=0
    Mol=0
    do iMType=1,NMType
        if (iPrint.ge.8) write(stdout,*) 'iMType',iMType
        do iNBond=1, NBondMType(iMType)                
            iBond=AdrBondMType(iMType)+iNBond
            if (iPrint.ge.8) write(stdout,*) 'iNBond',iNBond, iBond                
            if (BTypeBond(iBond).eq.2) then
                do iGrp=1, NSiteGroupsInBond(iBond)
                    if (iPrint.ge.8) write(stdout,*) 'igrp',igrp
                    do iMol=1, NMolMType(iMType)
                        if (iPrint.ge.8) write(stdout,*) 'iMol',iMol+Mol
                        if (iPrint.ge.8) write(stdout,*) 'AdrAtomMol',AdrAtomMol(iMol+Mol)
                        i=i+1
                        angles(i)%Atom1=AdrAtomMol(iMol+Mol)+iSiteInBond(iBond,iGrp)-AdrSiteMType(iMType)                            
                        angles(i)%Atom2=AdrAtomMol(iMol+Mol)+kSiteInBond(iBond,iGrp)-AdrSiteMType(iMType)                            
                        angles(i)%Atom3=AdrAtomMol(iMol+Mol)+jSiteInBond(iBond,iGrp)-AdrSiteMType(iMType)                            
                        angles(i)%Bond=iBond
                        angles(i)%LMove=BTest(StateB_iBond(iBond),5)
                        if (iPrint.ge.8) write(stdout,*) &
                                i, angles(i)%Atom1,angles(i)%Atom2,angles(i)%Atom3,angles(i)%Bond, angles(i)%LMove
                    enddo
                enddo
            endif
        enddo
        Mol=Mol+NMolMType(iMType)
    enddo        
    ! Construct arrays of angles specified for each atom:
    call reshape(NAngAtom, NAtom)
        ! Count in how many a-bonds each atom is involved
    NAngAtom=0    
    do i=1, NAngles
        NAngAtom(Angles(i)%Atom1)=NAngAtom(Angles(i)%Atom1)+1
        NAngAtom(Angles(i)%Atom2)=NAngAtom(Angles(i)%Atom2)+1
        NAngAtom(Angles(i)%Atom3)=NAngAtom(Angles(i)%Atom3)+1
    enddo
    ! Allocate real sized or 1-sized dummy arrays, depending on presence of angle-bonds
    call reshape2(AngAtom,max(Maxval(NAngAtom),1),NAtom)        
    call reshape(Phi_new, max(Maxval(NAngAtom),1))
    call reshape(Eang_new,max(Maxval(NAngAtom),1))

    NAngAtom=0
        ! Populate lists of a-bond for every atom
    if (iPrint.ge.8) write(stdout,*) 'NAngles:',NAngles
    do i=1, NAngles
!            iAngle=Angles(i)
        NAngAtom(Angles(i)%Atom1)=NAngAtom(Angles(i)%Atom1)+1            
        NAngAtom(Angles(i)%Atom2)=NAngAtom(Angles(i)%Atom2)+1            
        NAngAtom(Angles(i)%Atom3)=NAngAtom(Angles(i)%Atom3)+1
        AngAtom(NAngAtom(Angles(i)%Atom1),Angles(i)%Atom1)=i
        AngAtom(NAngAtom(Angles(i)%Atom2),Angles(i)%Atom2)=i
        AngAtom(NAngAtom(Angles(i)%Atom3),Angles(i)%Atom3)=i
    enddo

    if (iPrint.ge.8) then
        do i=1,NAtom
            write(stdout,*) 'Atom:', i, 'angles:', AngAtom(1:NAngAtom(i),i)
        enddo
    endif

!   NB----------------------------------------------        
    !Construct mask array - mask=true if pair is in NB, false elsewhere
    if (.not. allocated(MaskNB)) then
        allocate (MaskNB(NAtom,NAtom));allocate (MaskB(NAtom,NAtom)); allocate (MaskA(NAtom,NAtom))
        MaskNB=.True.; MaskB=.False.; MaskA=.False. ! Default                        
        do iAtom=1,NAtom            
            do jAtom=iAtom+1,NAtom
                if (MolAtom(iAtom).eq.MolAtom(jAtom)) then                        
                    MaskNB(jAtom,iAtom)=(Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom)).eq.0) ! If not bonded, then MaskNB=True                       
                    if (.not.MaskNB(jAtom,iAtom)) then ! if bonded
                        MaskB(jAtom,iAtom)=(BTypeBond(Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom))).eq.1)
                        MaskA(jAtom,iAtom)=(BTypeBond(Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom))).eq.2)
                    endif
                endif
            enddo
            MaskNB(iAtom,iAtom)=.false.
            MaskB(iAtom,iAtom)=.false.
            MaskA(iAtom,iAtom)=.false.
        enddo
    endif
    
    ! Set MaskNB false to frozen pairs  
    do iAtom=1,NAtom        
        do jAtom=iAtom+1,NAtom
            if (.not.Btest(StateNB_iSjS(STypeAtom(jAtom),STypeAtom(iAtom)),5)) & ! Frozen pair
                MaskNB(jAtom,iAtom)=.false.
        enddo
    enddo
        ! Set MaskB false to frozen bonds  
    do iAtom=1, NAtom
        do jBond=1,NBondsAtom(iAtom)
            jAtom=jAtomBond(jBond,iAtom)
            iBond=BondNum(jBond,iAtom)
            if (.not.Btest(StateB_iBond(iBond),5)) then 
                MaskB(jAtom,iAtom)=.false.
                MaskB(iAtom,jAtom)=.false.                
            endif
        enddo
    enddo
    ! Set MaskA false to frozen angles
    do i=1, NAngles
        if (.not.Btest(StateB_iBond(Angles(i)%Bond),5)) then
            MaskA(Angles(i)%Atom1,Angles(i)%Atom3)=.false.
            MaskA(Angles(i)%Atom3,Angles(i)%Atom1)=.false.
!            Angles(i)%LMove=.false.
        endif        
    enddo        
 
    ! Make matrixes symmetric
    do iAtom=1,NAtom
        do jAtom=iAtom+1,NAtom
                MaskNB(iAtom,jAtom)=MaskNB(jAtom,iAtom)
                MaskB(iAtom,jAtom)=MaskB(jAtom,iAtom)
                MaskA(iAtom,jAtom)=MaskA(jAtom,iAtom)
        enddo
    enddo

!        write(*,*) 'MaskNB',MaskNB
!        write(*,*) 'MaskB',MaskB
!        write(*,*) 'MaskA',MaskA   
!   call CorrelInit(NAtom, IndexGlobNB_riSjS,IndexGlobB_riBond,STypeAtom)
end subroutine

subroutine MCmodConstruct(NA, RMAX, RCUT,RECUT, NAtom,Nmol, BOX, COULF, ALPHA,&
    Svec, Wvec,XvecCOMMol, STypeAtom, PotNB_riSjS, ChargeAtom, SiteAtom, MolAtom,IND, &
    RMinPotB, RmaxPotB, NpointsPotB, PotB_riBond,&
    AdrAtomMol,MTypeMol, MassSite,SumMassMType,&
    iPrint,stdout,lprint, iStep)

    implicit none
    integer(4), intent(in) :: NA,NAtom,NMol, STypeAtom(:), SiteAtom(:),  MolAtom(:), NpointsPotB(:),&
    stdout, iPrint, AdrAtomMol(:), IND(:,:,:), MTypeMOl(:), istep
    real(8), intent(in)::  BOX(3), RCUT,RECUT, COULF, ALPHA, RMAX
    real(8), intent(in):: Svec(:,:),&
                        PotNB_riSjS(:,:,:), ChargeAtom(:), RMinPotB(:), RmaxPotB(:), PotB_riBond(:,:),&
                        MassSite(:), SumMassMType(:)
    real(8), intent(inout):: Wvec(:,:), XvecCOMMol(:,:)
    logical, intent(in) :: lprint

    integer(4) iAtom, jAtom, kAtom, jSite, kSite, jBond,iBond, MAxBonds , i, NR, iMol
    type(Angle) :: iAngle
    real(8):: Force, Energ, dr(3), threshold
    real(8), allocatable:: EijOld(:,:), EelijOld(:,:),RijOld(:,:),RijOld_vec(:,:,:)
    real(8) ENER_old, EINT_old, EINT_ang_old, EEL_old, EFUR_old, EFCOR, DE_old, DEE_old, DES_old, DE
    
!   Debugging part - allocate temporary arrays to keep old Rij and Eij values
    allocate(RijOld(size(Rij,1),size(Rij,2)))
    allocate(RijOld_vec(3,size(Rij,1),size(Rij,2)))
    allocate(EijOld(size(Eij,1),size(Eij,2)))
    allocate(EelijOld(size(Eelij,1),size(Eelij,2)))
    RijOld=Rij
    RijOld_vec=Rij_vec
    
    EijOld=Eij
    EelijOld=Eelij    
    DE_old=sum(Eij, mask=MaskNB)/2.0
    EINT_old=sum(Eij, mask=MaskB)/2.0
    EINT_ang_old=sum(Angles(:)%Eang,mask=Angles(:)%LMove)
    DEE_old=sum(Eelij,mask=MaskNB)/2.0
    DES_old=sum(Eelij,mask=(MaskB.or.MaskA))/2.0
!   NB----------------------------------------------   
! Recalculate COM and move COM of every molecule to the origin periodic box
    do iMol=1, NMol
        call MCgetCOM(iMol, MTypeMol,MassSite,SumMassMType,Wvec,BOX,AdrAtomMol,SiteAtom,XvecCOMMol)
    enddo
! Check agreement between SX and Ri_vec
    do iAtom=1, NAtom
!        dR=(Ri_vec(:,iAtom)-[SX(iatom), SY(iatom), SZ(iatom)])
        dR=(Ri_vec(:,iAtom)-Svec(:,iatom))
        call MCPBC(dr,BOX)
        if (sum(dr**2).gt.1e-8) then
            write(stdout,'(a,i5,9f9.4)') 'MCmodConstruct: Ri_vec!=SX:',iAtom, Ri_vec(:,iAtom), Svec(:,iatom),dr            
            stop
        endif
    enddo    
! Construct matrix of interparticle distances                 
    Rij_vec=0.0; Rij=0.0
    do iAtom=1,NAtom
        do jAtom=iAtom+1,NAtom     
            Rij_vec(:,jAtom,iAtom)=Ri_vec(:,jAtom)-Ri_vec(:,iAtom)
            Rij_vec(:,iAtom,jAtom)=-Rij_vec(:,jAtom,iAtom)                
        enddo
    enddo                            
    ! Apply PBC for the new vector distances
    do iAtom=1,NAtom
        call PBC_vec(Rij_vec(:,:,iAtom),BOX*0.5, BOX)         
        call PBC_vec(Rij_vec(:,:,iAtom),BOX*0.5, BOX)         
    enddo
    ! Calculate distance modulus            
    Rij=sqrt(sum(Rij_vec**2,dim=1))
    ! Make Rii - very high, to exclude self-interaction from estimation
    do iAtom=1,NAtom 
        Rij(iAtom,iAtom)=max(RCUT,RMAX)+1.0
    enddo       

    ! Calculate short-range NB energy terms  where r<rcut
    Eij=0.0; Eelij=0.0
    do iAtom=1,NAtom
        do jAtom=iAtom+1,NAtom
            if (MaskNB(jAtom,iAtom)) then                  
                if (Rij(jAtom, iAtom).le.RCUT) then
!                    Eij(jAtom, iAtom)=ENERG_elemental(Rij(jAtom,iAtom),STypeAtom(jAtom),STypeAtom(iAtom),NA,RMAX,PotNB_riSjS)                                    
                    call EnergyForce(Rij(jAtom,iAtom),STypeAtom(jAtom),STypeAtom(iAtom),NA,RMAX,PotNB_riSjS,Energ, Force)                                    
                    Eij(jAtom, iAtom)=Energ
                    VIRij(jAtom,iAtom)=Force*Rij(jAtom,iAtom)
                    ! Check if no states with g(r)=0 are occupied.
		    NR=Rij(jAtom,iAtom)/RDFINC+1
                    if((IND(NR,STypeAtom(iAtom),STypeAtom(jAtom)).eq.0).and.(lprint)) then
                        write((stdout),'(a,3i4,f12.4)')'MCmodConstruct: Wrong configuration:',iAtom, jAtom, NR,Rij(jAtom,iAtom)
                        write((stdout),*) Rij_vec(:,jAtom,iAtom)                            
                    end if   !  if(IND...
                endif
            endif
        enddo            
    enddo
    ! Calculate pairwise Bond energy terms  where r<rcut    
    do iAtom=1, NAtom
        do jBond=1,NBondsAtom(iAtom)
            jAtom=jAtomBond(jBond,iAtom)
            iBond=BondNum(jBond,iAtom)
            if ((Rij(jAtom,iAtom).lt.RMinPotB(iBond)).or.((Rij(jAtom,iAtom).gt.RMaxPotB(iBond)))) then
                write(stdout,*) 'Error: MCMod Construct. Bond length beyond allowed range.'
                write(stdout,*) 'Atoms:',iAtom, jAtom
                write(stdout,*) 'BondNumber, RMin, RMax, R:',iBond,RMinPotB(iBond),RMaxPotB(iBond),Rij(jAtom,iAtom)
                stop
            endif
            call EneriForci(Rij(jAtom,iAtom),iBOnd,RMinPotB(iBOnd),&
                    RMaxPotB(iBond),PotB_riBond,NPointsPotB(iBond),stdout,Energ, Force)
            Eij(jAtom,iAtom)=Energ
            VIRij(jAtom,iAtom)=Force*Rij(jAtom,iAtom)
        enddo
    enddo
    
    ! Calculate electrostatic terms or corrections
!    write(*,*) 'Debug Elstat Bonds'
    do iAtom=1,NAtom
        do jAtom=iAtom+1, NAtom
!            write(*,*) iAtom, jAtom,ChargeAtom(iAtom), ChargeAtom(jAtom),ChargeAtom(jAtom)*ChargeAtom(iAtom)
            if ((ChargeAtom(jAtom)*ChargeAtom(iAtom).ne.0.0)) then  
!                write(*,*) 'Charged:', iAtom, jAtom, ChargeAtom(iAtom), ChargeAtom(jAtom)
                if (MaskNB(jAtom,iAtom).and.(Rij(jAtom,iAtom).le.RECUT)) &
                  Eelij(jAtom,iAtom)=ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*derfc(ALPHA*Rij(jAtom,iAtom))/Rij(jAtom,iAtom)
                if (MaskB(jAtom,iAtom).or.MaskA(jAtom,iAtom)) & ! Bonded
                  Eelij(jAtom,iAtom)=ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*((derfc(ALPHA*Rij(jAtom,iAtom))-1.)/Rij(jAtom,iAtom))                                    
            endif
        enddo
    enddo
    ! Make cross matrixes symmetric
    do iAtom=1,NAtom
        do jAtom=iAtom+1, NAtom
            Eij(iAtom,jAtom)=Eij(jAtom,iAtom)
            Eelij(iAtom,jAtom)=Eelij(jAtom,iAtom)
            VIRij(iAtom,jAtom)=VIRij(jAtom,iAtom)
        enddo
    enddo    

    ! Calculate angles
    do i=1, NAngles
        Angles(i)%Phi=dacos(0.9999999*& !This is to avoid 180 degrees angle, which cause floating point error
                            dot_product(Rij_vec(:,Angles(i)%Atom1,Angles(i)%Atom2),Rij_vec(:,Angles(i)%Atom3,Angles(i)%Atom2))&
                                            /(Rij(Angles(i)%Atom1,Angles(i)%Atom2)*Rij(Angles(i)%Atom3,Angles(i)%Atom2)))*RAD2DEG
    enddo
    ! Check ABond ranges
    do i=1, NAngles
        iAngle=Angles(i)
        if (iAngle%Phi.gt.RMaxPotB(iAngle%Bond).or.(iAngle%Phi.lt.RMinPotB(iAngle%Bond))) then 
            write(stdout,*) 'Error: MCMod Construct. Bond angle beyond allowed range.'
            write(stdout,*) 'Atoms:',iAngle%Atom1,iAngle%Atom2,iAngle%Atom3
            write(stdout,*) 'BondNumber, PhiMin, PhiMax, Phi:',iAngle%Bond,RMinPotB(iAngle%Bond),RMaxPotB(iAngle%Bond),iAngle%Phi
            stop
        endif
    enddo
    ! Calculate Angle-Bond energies
    do i=1, NAngles
        call EneriForci(Angles(i)%Phi,Angles(i)%Bond,RMinPotB(Angles(i)%Bond),RMaxPotB(Angles(i)%Bond),&
                    PotB_riBond,NPointsPotB(Angles(i)%Bond),stdout, Energ, Force)
        Angles(i)%Eang=Energ
    enddo
    !Summary
    if (iprint.ge.8) then
        write(stdout,*) 'MCmod Construct: Short-Range Non-Bonded energy:', sum(Eij, mask=MaskNB)/2.0*FKJM
        write(stdout,*) 'MCmod Construct: Real space electrostatic Non-Bonded energy:', sum(Eelij,mask=MaskNB)/2.0*FKJM
        write(stdout,*) 'MCmod Construct: Pairwise Bonds energy:', sum(Eij, mask=MaskB)/2.0*FKJM
        write(stdout,*) 'MCmod Construct: Angle Bonds energy:', sum(Angles(:)%Eang)*FKJM        
    endif
    
    ! Check differences between initial values and recalculated values:
    if (istep.gt.0) then 
        threshold=1e-3
        do iAtom=1,NAtom
            do jAtom=iAtom+1,NAtom     
                if (abs(RijOld(jAtom,iAtom)-Rij(jAtom,iAtom)).gt.threshold) then
                    write(stdout,*) &
                        'Error: MCmod Construct: reConstructed distance Rij differs from the original value.',&
                        'i,j=',iAtom, jAtom, ' RijOld:', RijOld(jAtom,iAtom), ' Rij:', Rij(jAtom,iAtom),&
                        ' delta=',RijOld(jAtom,iAtom)- Rij(jAtom,iAtom), ' step:',istep!;  stop
			stop
                endif
                if (abs(EijOld(jAtom,iAtom)-Eij(jAtom,iAtom)).gt.threshold) then
                    write(stdout,*) 'Error: MCmod Construct: reConstructed Energy Eij differs from the original value.',&
                        'i,j=',iAtom, jAtom, ' EijOld:', EijOld(jAtom,iAtom), ' Eij:', Eij(jAtom,iAtom),' step:',istep
                    write(stdout,*) &
                        ' RijOld:', RijOld(jAtom,iAtom), ' Rij:', Rij(jAtom,iAtom),&
                        ' delta=',RijOld(jAtom,iAtom)- Rij(jAtom,iAtom), ' step:',istep!;  stop
			stop
                endif
                if (abs(EelijOld(jAtom,iAtom)-Eelij(jAtom,iAtom)).gt.threshold) then
                    write(stdout,*) 'Error: MCmod Construct: reConstructed El.stat. energy Eelij differs from the original value',&
                        'i,j=',iAtom, jAtom, ' EelijOld:', EelijOld(jAtom,iAtom), ' Eelij:', Eelij(jAtom,iAtom),' step:',istep
                    write(stdout,*) &
                        ' RijOld:', RijOld(jAtom,iAtom), ' Rij:', Rij(jAtom,iAtom),&
                        ' delta=',RijOld(jAtom,iAtom)- Rij(jAtom,iAtom), ' step:',istep,&!;  stop
                        'Ri_vec,Rj_vec=',Ri_vec(:,iAtom),Ri_vec(:,jAtom)
                        stop
                endif
            enddo
        enddo    
	dE= DE_old-sum(Eij, mask=MaskNB)/2.0+&
	    EINT_old-sum(Eij, mask=MaskB)/2.0+&
	    EINT_ang_old-sum(Angles(:)%Eang,mask=Angles(:)%LMove)+&
	    DEE_old-sum(Eelij,mask=MaskNB)/2.0+&
	    DES_old-sum(Eelij,mask=(MaskB.or.MaskA))/2.0

            if((dabs(dE).gt.threshold)) then
	    	write((stdout),'(2(a,f14.5))') 'MCmodInit: Error after construct in energy'
        	write((stdout),*) 'Deviations in Energy:',&
				'Enb:',DE_old-sum(Eij, mask=MaskNB)/2.0,&
				'Eelnb',DEE_old-sum(Eelij,mask=MaskNB)/2.0,&
				'Eb',EINT_old-sum(Eij, mask=MaskB)/2.0,&
				'Ea',EINT_ang_old-sum(Angles(:)%Eang,mask=Angles(:)%LMove)
                                        
	    endif
    
             
    endif
end subroutine

subroutine FrozenEnergy(NAtom, NA,  StateNB_iSjS, StateB_iBond, STypeAtom, SiteAtom, Bond_iSjS,MolAtom,&
                        NBondsAtom,BondNum, jAtomBond, NPointsPotB, RCUT,RMAX,RECUT, BOX, ChargeAtom, &
                        RMinPotB, RMaxPotB,PotNB_riSjS,PotB_riBond,&
                        COULF, ALPHA, stdout )
    implicit none
    integer, intent (in):: NAtom, NA,  StateNB_iSjS(:,:), StateB_iBond(:), STypeAtom(:), SiteAtom(:), Bond_iSjS(:,:),MolAtom(:),&
                        NBondsAtom(:),BondNum(:,:), jAtomBond(:,:), NPointsPotB(:), stdout 
    real(8), intent(in) :: RCUT,RMAX, BOX(3), ChargeAtom(:), RMinPotB(:), RMaxPotB(:),PotNB_riSjS(:,:,:),PotB_riBond(:,:),&
                        COULF, ALPHA, RECUT
    
    real(8) Rij_frozen_vec(3), Rij_frozen,Phi_frozen ,R12(3), R13(3), R32(3), energ, force
    integer(4) iAtom, jAtom, iBOnd, jBond, i
        ! Calculate Total energy contribution from the frozen pairs
    ENB_frozen=0.0; EB_frozen=0.0; EA_frozen=0.0;   EelNB_frozen=0.0; EelBA_frozen=0.0
    VIRij_frozen=0.0; VIRIij_frozen=0.0
    do iAtom=1,NAtom
        do jAtom=iAtom+1,NAtom
            if (.not.Btest(StateNB_iSjS(STypeAtom(jAtom),STypeAtom(iAtom)),5)) then ! Frozen pair
                Rij_frozen_vec=Ri_vec(:,jAtom)-Ri_vec(:,iAtom)
                call MCPBC(Rij_frozen_vec,BOX)
                Rij_frozen=sqrt(sum(Rij_frozen_vec**2))            
                if ((MolAtom(iAtom).ne.MolAtom(jAtom)).or.& !Different molecules
                    ((MolAtom(iAtom).eq.MolAtom(jAtom)).and.Bond_iSjS(SiteAtom(jAtom),SiteAtom(iAtom)).eq.0)) then !Not a bonded pair                       
                    if (Rij_frozen.le.RCUT) then    
                        call EnergyForce(Rij_frozen,STypeAtom(jAtom),STypeAtom(iAtom),NA,RMAX,PotNB_riSjS,Energ, Force)                                    
                        ENB_frozen=ENB_frozen+Energ
                        VIRij_frozen=VIRij_frozen+Force*Rij_frozen
                        ! Check if no states with g(r)=0 are occupied.
                    endif
                    if (Rij_frozen.le.RECUT) then
                        EelNB_frozen=EelNB_frozen+ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*derfc(ALPHA*Rij_frozen)/Rij_frozen
!                        write(*,*)'Energy_frozen:', iatom,jatom,Rij_frozen, COULF, ALPHA,&
!                        ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*derfc(ALPHA*Rij_frozen)/Rij_frozen
                    endif
                    
                endif
            endif
        enddo            
    enddo
    
    do iAtom=1, NAtom        
        do jBond=1,NBondsAtom(iAtom)
            iBond=BondNum(jBond,iAtom)
            jAtom=jAtomBond(jBond,iAtom)
            if (.not.Btest(StateB_iBond(iBond),5)) then ! Frozen pair            
                if (jAtom.gt.iAtom) then
                    Rij_frozen_vec=Ri_vec(:,jAtom)-Ri_vec(:,iAtom)
                    call MCPBC(Rij_frozen_vec,BOX)
                    Rij_frozen=sqrt(sum(Rij_frozen_vec**2))            
                    if ((Rij_frozen.lt.RMinPotB(iBond)).or.((Rij_frozen.gt.RMaxPotB(iBond)))) then
                        write(stdout,*) 'Error: MCMod Init: Frozen Pairs Energy calculation . Bond length beyond allowed range.'
                        write(stdout,*) 'Atoms:',iAtom, jAtom
                        write(stdout,*) 'BondNumber, RMin, RMax, R:',iBond,RMinPotB(iBond),RMaxPotB(iBond),Rij(jAtom,iAtom)
                        stop
                    endif
                    call EneriForci(Rij_frozen,BondNum(jBond,iAtom),RMinPotB(BondNum(jBond,iAtom)),&
                            RMaxPotB(BondNum(jBond,iAtom)),PotB_riBond,NPointsPotB(BondNum(jBond,iAtom)),stdout,Energ, Force)
!                    write(stdout,*) 'Frozen EB, EelB, i,j:',iAtom, jAtom,  Energ,&
!                        ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*((derfc(ALPHA*Rij_frozen)-1.)/Rij_frozen)
                    EB_frozen=EB_frozen+Energ
                    VIRIij_frozen=VIRIij_frozen+Force*Rij_frozen
                    EelBA_frozen=EelBA_frozen+ChargeAtom(iAtom)*ChargeAtom(jAtom)*COULF*((derfc(ALPHA*Rij_frozen)-1.)/Rij_frozen)       
                endif
            endif
        enddo
    enddo

    ! Calculate frozen Angle-Bond energies
    do i=1, NAngles
        if (.not.BTest(StateB_iBond(Angles(i)%Bond),5)) then ! if frozen
            R12=Ri_vec(:,Angles(i)%Atom2)-Ri_vec(:,Angles(i)%Atom1)
            R32=Ri_vec(:,Angles(i)%Atom2)-Ri_vec(:,Angles(i)%Atom3)
            R13=Ri_vec(:,Angles(i)%Atom3)-Ri_vec(:,Angles(i)%Atom1)
            Phi_frozen=dacos(dot_product(R12,R32)/(sqrt(sum(R12**2))*sqrt(sum(R32**2))))*RAD2DEG
            if (Phi_frozen.gt.RMaxPotB(Angles(i)%Bond).or.(Phi_frozen.lt.RMinPotB(Angles(i)%Bond))) then 
                write(stdout,*) 'Error: MCMod Init: Frozen Energy. Bond angle beyond allowed range.'
                write(stdout,*) 'Atoms:',Angles(i)%Atom1,Angles(i)%Atom2,Angles(i)%Atom3
                write(stdout,*)'BondNumber, PhiMin, PhiMax, Phi:',&
                    Angles(i)%Bond,RMinPotB(Angles(i)%Bond),RMaxPotB(Angles(i)%Bond),Phi_frozen
                stop
            endif
            call EneriForci(Phi_frozen,Angles(i)%Bond,RMinPotB(Angles(i)%Bond),RMaxPotB(Angles(i)%Bond),&
                    PotB_riBond,NPointsPotB(Angles(i)%Bond),stdout, energ, force)
            EA_frozen=EA_frozen+energ
            EelBA_frozen=EelBA_frozen+ChargeAtom(Angles(i)%Atom1)*ChargeAtom(Angles(i)%Atom3)*COULF*&
                            ((derfc(ALPHA*sqrt(sum(R13**2)))-1.)/sqrt(sum(R13**2)))       
        endif
    enddo
    write(stdout,*) 'MCmod: FrozenEnergy: Etotal:',(ENB_frozen+EB_frozen+EA_frozen+EelNB_Frozen+EelBA_frozen)*FKJM,&
                 ' ENB_frozen:',ENB_frozen*FKJM,&
                ' EB_frozen:', EB_frozen*FKJM,' EA_frozen:',EA_frozen*FKJM,'  EelNB:', EelNB_frozen*FKJM,&
                '  Eel(BandA):', EelBA_frozen*FKJM
    write(stdout,*) 'MCmod: FrozenEnergy: Virial NB:',VIRij_frozen, '  Virial B:', VIRIij_frozen
end subroutine        
