!DEC$ FREEFORM
!   Declarations of all global variables.
include "dimpar.h"
character(filename_text) &
        FILPOT,&         ! file with potentials
        FILRDF,&         ! file with RDFs/ADFs
        FSTART,&          ! name of file with initial coordinates (velocities)
        BaseOutFileName,& ! Filename template to use for writing output files
        OutFileName,&         ! Auxilary variable used to generate current names for potential, trajectory, structure output.
        FCRD           !File with starting coordinates of frozen molecules.                
                
character(atom_name_len), allocatable:: &
        NameSite(:),&   ! Names of atoms in all atoms list
        NameSType(:)    ! Names of atomic types, in same order as they appear in RDF-file
character(mol_name_len), allocatable:: &
        NameMType(:)    ! Names of molecular types                  
logical, allocatable::  LMoveMType(:)      ! Should we move this type of molecules
        
logical LPOT,& ! Should we read potential from file? If no LRDF must be "true"
	LZEROPOT,& ! Set initial potential to zero
   	LRDF,& ! Perform inverse simulation (and read target RDF from file)   	
        LXMOL,& ! If to dump last configuration to the file
   	LIMC, & ! Perform Inverse MC ,
        LPotCorrCheck,& ! If the Potential Correction check is enabled ?
        LCRD,&  ! Start from coordinates in FSTART file, otherwise start from random configuration
        LCRDPass,& !Pass last MC configuration as starting on following IMC iteration.
        LEV!,& !Perform Eigenvalues and eigenvectors search ?

real(8), allocatable:: &
        RSite(:,:),& ! Coordinates of all sites of each molecular type, readed from MCM-file
	ChargeSite(:),& ! Charges of each site of system
	MassSite(:),& ! Mass of each atom of each molecular type
	RMinPotB(:),& ! Minimal radius for i-th intramolecular potentinal
	RMaxPotB(:),&  ! Maximal radius for i-th intramolecular potentinal
        SumMassMType(:),& !Mass of the molecule of type ITYP
        MCStepAtomMType(:),&! Max displacement in MC step for atomes of each MolType(single atom shift)
        MCTransStepMType(:),MCRotStepMType(:),& ! Size of MC translation/rotation of the whole molecule in Angstroms/degrees
        MCStepAtomARMType(:),MCTransStepARMType(:), MCRotStepARMType(:), & ! Desired Acceptance ratios for MC step autoajdustment
    	XvecCOMMol(:,:),&! Coordinates of Center of Mass (COM) of each molecule
        Svec(:,:) ,& ! Coordinates of all atoms of system
	Wvec(:,:),& ! Coordinates of atom relative to MTypeSite molecule's COM
	ChargeAtom(:),& ! Charge of iat-th atom in the global atomlist
        PotNB_riSjS(:,:,:),&        ! POT(iNA,isg,jsg)	value of intermolecular potential between isg-jsg atomic types on distance iNA
        PotB_riBond(:,:),&         ! POTI(iNST,IPP) - iNST-th point of IPP-th intramolecular potential/bond
        Recvec(:,:),& ! Reciprocal space vercors for Ewald
        RKV(:),&            ! Coefficient in Fourier part of Ewald method, which is a function of K**2
        SSIN(:),&           ! SSIN(1:NKV)   array of sum(q(i)*sin(K*r(i))) over all possible vectors K(1:NKV)
        SCOS(:),&           ! SCOS(1:NKV)	array of sum(q(i)*cos(K*r(i))) over all possible vectors K(1:NKV)
        PotCorrJourn(:,:)   ! Array to keep record of global potential corrections on different checkpoints within one IMC-iteration

real(8) :: &
        BOX(3),& !          ! Periodic cell size
        VOL,&               ! Periodic cell volume
        ENER,&              ! Current (running) total energy of the system
        EINT,&              ! Current internal (intramolecular pairwise bonds) energy
        EINT_ang,&          ! Current internal angular (intramolecular bemding angle bonds) energy
        EEL,&               ! Electrostatic energy of the system
        EFUR,&              ! Fourier part of electrostatic energy in Ewald sum
        ESF,&               ! Fourier part of electrostatic self-interaction energy
        DE,&                ! Total energy change in MC step
        COULF,&             ! Coeffitient to convert electrostatic energy to internal units. 1.d10*ELCH**2/(4.d0*PI*EPS0*EPS*BOLTZ*TEMP)
        FQ,ALPHA,AF,&       ! Electrostatic interaction parameters        
        ENERS,&             ! Accumulator for averaging Total Energy
        EELS,&              ! Accumulator for averaging Electrostatic Energy
        EINTS,&              ! Accumulator for averaging Internal Energy
        RCUT,&              ! Real-space cutoff radius for short-range LJ interactions
        RECUT,&             ! Real space cutoff radius for direct electrostatics part
        RMIN,RMAX,&         ! Min and Max distances in intermolecular RDFs. RMAX defines Short-Range cutoff radius.
        VIR,VIRS,VIRE,VIRI,VIIS,& ! Pressure-related variables
        RDFINC,&            ! Auxilary variable - dR in RDF
        EPS,&               ! Dielectric permittivity
        POTCUT,&            ! Higher border for potential value.
        TEMP,&              ! Desired temperature of the system
        FRT,&               !Energy conversation factor. Internal units -> KJ/mol
     	REGP,&              ! Regularization parameter
        DPOTM,&             ! Max change of the potential
        RTM,&               ! Max relative difference in potential correction
        FPR,&               ! Pressure conversion factor
        PotCorrCheckLevel,& ! Convergence criteria level value.
!        FNR,&               ! 1/NAV
        PRES,&              ! Pressure
!        CRR,&               ! Auxilary variable for calulating reference <S>
!        CRC,&               ! Auxilary variable for calulating resulting <S>
        MixEV ! Coefficient of EigenVector mixing
     	

integer(4) ::&        
     	NMType,&              ! Number of molecular types
        NBond,&              ! Number of intramolecular RDFs
!        IBB,&               ! Global counter of atom pairs involved in bonds
        ITRANS,&            ! How often to make MCtranslation step
        IROT,&              ! How often to make MCrotation step
        NMol,&               ! Total number of molecules in system
        NA,&                ! Number of points in one intermolecular RDF/potential (resolution)
!        NMAXI=0,&           ! Maximum number of points in a intramolecular potential	
	ISTEP=0,&           ! Current (running) MC/MD step
        NKV,&               ! Number of reciprocal space vectors
	NAV,&               ! Number of sampled (averaged) configurations
        IPRINT,&            ! Output verbosity level
        stdout,&            ! Unit to print messages
        NSType,&               ! Total number of atom types in the system
        NAtom,&             ! Total number of atoms in system
        NSite,&              ! Number of atomsites (total number of atoms in list of molecule types) in the system                
	NBondB=0,NBondA=0,&       ! Number of intramolecular pair potentials and covalent angle bending potentials
        I,J,&                 ! Auxilary
        IREP=1,&              ! Number of current IMC/IBI iteration
        IREPT,&            ! Total number of IMC/IBI iterations to perform
        ITR,&               ! How often to wtire trajectory to a file     	
        NAtomChrgAtom,&             ! Number of charged atoms in the system
        IOUT,&              !How often to recalculate total energy/write energies in output
        IAV,&               !How often to compute averages
        NRS,&               ! Random number generator starting seed
        NMCAutoAdjust, &    ! How often to perform MC step autoadjustment during equilibration phase
        IPotCorrCheck,&       ! How often to perform Potential Corection Check.
        NactNB,&                ! Number of Intermolecular potentials
        NFStart             ! Number of first configurations to be randomly picked from starting configuration file

integer(4), allocatable::&
        NMolMType(:),&          ! Number of molecules of each type        
	NSiteMType(:),&          ! Number of atoms in molecule of each type
	AdrAtomMType(:),&         ! Address of first molecule of i-th type in atom list (number first atom of first molecule of type i-th) //index in the global atomlist of (the first atom of the molecular type iMolType) -1 (preceding atom)
	AdrSiteMType(:),&          ! Address of molecule type in site list // index in the global sitelist after which sites of the molecular type NMTypee will stand
	AdrMolMType(:),&           ! Address of i-th molecular type in row of all molecules (first molecule of i-th type in molecule list) //index in the global moleculelist of the last molecule with type (iMol-1) (preceding moleculetype)
	NBondMType(:),&            ! number of bonds in molecule of type iTYPE
        AdrBondMType(:),&           ! number of bond after which bonds belonging to molecular type NMType are located
        MTypeSType(:),&          ! Molecular type of molecule that atomic type iNSN belongs to
	IndexGlobNB_riSjS(:,:,:),&       ! Point in a global RDF/potential array which refers to NA-th point of potenial/RDF between iSG-th and jSG-th global atom types        
	IND(:,:,:),&        ! Array of marks for each point of IndexGlobNB_riSjS: -3, potential is known, but protected for corrections, -2 no data about this RDF/potential (whole potential is zero), -1 some points are missing, 0 RDF has zero value in this point and potential has high (prohibiting) value; 1 - RDF is nonzero and poential has normal value.
        IndexGlobB_riBond(:,:),&        ! IPOTI(iNST,IPP) Point in a global RDF/potential array which refers to iNst-th point of IPP-th potenial/RDF
        INDI(:,:),&         ! Array of marks for each point of IndexGlobNB_riSjS
	MTypeMol(:),&            ! Type of i-th molecule in general molecule list
	AdrAtomMol(:),&          ! Address of i-th molecule in general atom list (given by number of first atom of molecule - 1)
	Bond_iSjS(:,:),&        ! rdf/potential which iX-th and iY-th pair of sites refers to
	MTypeSite(:),&            ! MTypeSite(iS) number of molecular type that site with index iS belongs to
        NPairsTotalBond(:),&           ! NPairsTotalBond(NBond) Number of atom pairs to be accounted for intramolecular RDF at each analyzed configuration. Used for RDF normalization
	NSiteGroupsInBond(:),&           ! NPTT(NBond) Number of site pairs/triplets which refers to NBond-th RDF/potential  ADF/angle-potentials
	iSiteinBond(:,:),jSiteinBond(:,:),kSiteinBond(:,:),& ! Sites (i,NBond) which refer to i-th pair(triplet) of NBond intramolec bond
	NPointsPotB(:),&            ! Number of points in i-th intramolecular potential
	NMIN(:),&           ! NMIN(IPP) - Array keeps point where ipp-th intramolecular potential has MTypeSite minimum.
        MolAtom(:),&           ! global number of the molecule, that atom with index i belongs to
        StateNB_iSjS(:,:), StateB_iBond(:), & ! Bit-mask for every NB, B interaction
        BTypeBond(:),&      ! Bond type (0-pairwise, 1-angle bending)
        MTypeBond(:),&      ! Molecule type the bond belongs to
        STypeAtom(:),&      ! global atomic type of atom with global index i
        SiteAtom(:),&       ! global site's number which refers to atom with global index iat
        AtomChrgAtom(:),&          ! AtomChrgAtom(NAtomChrgAtom) Global index of NAtomChrgAtom-atom  in list of charged atoms
        SitesInGroupBondMType(:,:,:,:),& ! SitesInGroupBondMType(3,i,NBondA,ITYP) I-th triplet of sites involved in covalent-angle bond of type IBB-NBondB (numbering excluding pair bonds) in molecular type ITYP
        SideSiteABond(:,:,:),& ! SideSiteABond(2,i,isite) I-th dublet of sites involved in same covalent angle bond as site isite. Given site are sides of angle and isite is MTypeSite edge
        NABondSite(:),& ! SiteABondMType(NBondA+1,NMType) number of covalent angle bonds which site isite involved in
        SiteABondMType(:,:),& ! NABondSite(isite) List of angle bond types in molecular type NMType. Last cell (NBondA+1,NMType) keeps number of bond types, and first cells in a row keep numbers ov these types.
        EdgeSiteABond_iSjS(:,:) ! EdgeSiteABond_iSjS(isite,jsite) Site which stands on edge of covalent angle bond between sites isite,jsite

integer(8), allocatable::&
        CORS(:),&           ! <S_i> - local value for each process (in MPI case)
        CORP(:,:),&         ! <S_i*S_j>    local value for each process (in MPI case)
        AccCntMType(:,:,:),& ! total steps/accepted steps counter for MC steps:  first index - MolType; second index = 1:accepted steps, 2:total steps; third index  1-single atom, 2-molecule translation, 3 - molecule rotation;
        npairsrdf(:,:) ! Arrays for counting number of pairs for intermolecular RDFs for normalization.                

integer(8) &
!       NPAIR,& ! Integer to output number of pairs accounted for RDF
        NMCSteps,&              ! Total number of MK/MD steps do be performed in each MC/MD process.
        NMCStepsEquil ! Number of equilibration MC steps
        

! Group of variables needed for MPI implementation ------------------------------------  
integer(4):: global_NAV,& ! general number of averaged configurations
            ID=0,& ! Id of the process: 0-serial run, 1-parallel run master process, >1 parallel run slave-process.
            psize=0,& ! Number of processes in parallel run
            rank=0,& ! Number of current MPI process
            ierror ! MPI-related error message ID
  
integer(8) global_MKSteps ! general number of MK-steps performed in one IMC interation (total number over all processes)
  integer(8), allocatable::global_npairsrdf(:,:),global_CORP(:,:), global_CORS(:),& ! Arrays for MPI-based gathering and averaging of correlators
            global_AccCntMType(:,:,:) !Total Acceptance counter over all processes for MC steps: 1-single atom, 2-molecule translation, 3 - molecule rotation
  real(8) global_EELS, global_EINTS, global_ENERS,&
          global_VIRS,global_VIRE,global_VIIS ! components of pressure averaged over all processes

!      save
! Variables for timing
REAL(8) :: t_rate
integer(8):: cnt_wall_beg, cnt_wall_end, cnt_rate,cnt_wall_bigbang

character(len=5) :: fmt !Auxilary variable for output format specification